#!/usr/bin/env python
# -*- coding: gb2312 -*-
import datetime
import os
import random
import sys
import time
from datetime import date

sys.path.append("Tag")
import server, security, record, dataprovider, tag


class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider
        self.myTag = tag.Tag()

    def AddTag(self):
        attr = {'tagname': 'srctag', 'tagtype': 'int8'}
        try:
            self.myTagMgr.add_tag(**attr)
        except Exception as e:
            print("add_tag error: ", e.errcode)
        else:
            print("adding tag succeeds")

    def AddCalcTags(self):
        props = [{'tagname': 'catag0',
                      'tagtype': 'int32',
                      'szCalcExpr': '\'srctag\'+1',
                     'szSourceTagName':'srctag',
                     'nCalcMode' : 0,
                     'nCalcPeriod' :5
                     },{'tagname': 'catag1',
                      'tagtype': 'int32',
                      'szCalcExpr': '\'srctag\'+1',
                     'szSourceTagName':'srctag',
                     'nCalcMode' : 0,
                     'nCalcPeriod' :5
                     }]
        try:
            tagcalcids = self.myTagMgr.add_calc_tags(props=props)
        except Exception as e:
            print("add_calc_tags error: ", e.errcode)
        else:
            print("adding calc tags succeeds")

    def GetTag(self):
        try:
            tag0 = self.myTagMgr.get_tag(tagname='catag0')
        except Exception as e:
            print("get_tag error: ", e.errcode)
        else:
            print("tagname: ", tag0.tagname, "tagclass: ", tag0.tagclass)
        try:
            tag1 = self.myTagMgr.get_tag(tagname='catag1')
        except Exception as e:
            print("get_tag error: ", e.errcode)
        else:
            print("tagname: ", tag1.tagname, "tagclass: ", tag1.tagclass)

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")

if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")

    testA.ConnectServer()
    time.sleep(15)
    testA.AddTag()
    time.sleep(15)
    testA.AddCalcTags()
    time.sleep(15)
    testA.GetTag()
    time.sleep(15)
    testA.Disconnet()
