#!/usr/bin/env python
# -*- coding: gb2312 -*-

from ctypes import *
import hyperdb
import sys
from datetime import datetime
import time


class CollectorMgr(object):

    ##Ӳɼ
    # @param name ɼ
    # @param collectortype 
    # // ɼ
    # enum HD3_COLLECTOR_TYPE {
    # HD3_COLLECTOR_TYPE_MIN = -1,
    # HD3_COLLECTOR_TYPE_INVALID = HD3_COLLECTOR_TYPE_MIN,
    # HD3_COLLECTOR_TYPE_OPC,
    # HD3_COLLECTOR_TYPE_MODBUS,
    # HD3_COLLECTOR_TYPE_RDB,
    # HD3_COLLECTOR_TYPE_HD2HD,
    # HD3_COLLECTOR_TYPE_MAX = HD3_COLLECTOR_TYPE_HD2HD
    # };
    # @param desc 
    # @param extparam չ
    # ʧܣ׳hyperdb.HDError쳣
    # @return hyperdb.hd_sucess
    def add_collector(self, name, collectortype, description, extparam):
        if type(name) != str or type(collectortype) != int:
            raise TypeError

        if type(description) != str or type(extparam) != str:
            raise TypeError

        collector_name = name
        collector_desc = description
        collector_extparam = extparam

        collector = hyperdb.HD3Collector()
        collector.szName = collector_name.encode('utf-8')
        collector.nType = collectortype
        collector.szDescription = collector_desc.encode('utf-8')
        collector.szExtParam = collector_extparam.encode('utf-8')

        collectorid = c_uint32()

        hyperdb.api.ct3_add_collector.argtypes = [POINTER(hyperdb.HD3Collector), POINTER(c_uint32)]
        retcode = hyperdb.api.ct3_add_collector(byref(collector), byref(collectorid))
        if hyperdb.hd_sucess != retcode:
            raise hyperdb.HDError(retcode)

    def delete_collector(self, name):
        if type(name) != str:
            raise TypeError

        collector_name = name.encode('utf-8')
        collector_id = c_uint32()
        hyperdb.api.ct3_query_collector_id_by_name.argtypes = [c_char_p, POINTER(c_uint32)]
        retcode = hyperdb.api.ct3_query_collector_id_by_name(collector_name, byref(collector_id))
        if hyperdb.hd_sucess != retcode:
            raise hyperdb.HDError(retcode)

        hyperdb.api.ct3_delete_collector.argtypes = [c_uint32]
        retcode = hyperdb.api.ct3_delete_collector(collector_id)
        if hyperdb.hd_sucess != retcode:
            raise hyperdb.HDError(retcode)

    def get_all_collectors(self):
        collector = hyperdb.HD3Collector()
        hditer = c_void_p()

        hyperdb.api.ct3_query_all_collectors.argtypes = [POINTER(c_void_p)]
        retcode = hyperdb.api.ct3_query_all_collectors(byref(hditer))
        if hyperdb.hd_sucess != retcode:
            raise hyperdb.HDError(retcode)

        iterate = hyperdb.Iterate(hditer, collector)
        return iterate

    def get_collector(self, name):
        if type(name) != str:
            raise TypeError

        collector_name = name.encode('utf-8')
        hdcollector = hyperdb.HD3Collector()
        collector_id = c_uint32()
        hyperdb.api.ct3_query_collector_id_by_name.argtypes = [c_char_p, POINTER(c_uint32)]
        retcode = hyperdb.api.ct3_query_collector_id_by_name(collector_name, byref(collector_id))
        if hyperdb.hd_sucess != retcode:
            raise hyperdb.HDError(retcode)

        hyperdb.api.ct3_query_collector.argtypes = [c_uint32, POINTER(hyperdb.HD3Collector)]
        retcode = hyperdb.api.ct3_query_collector(collector_id, byref(hdcollector))
        if hyperdb.hd_sucess != retcode:
            raise hyperdb.HDError(retcode)

        collectorid = hdcollector.nID
        collectorname = hdcollector.szName.decode('utf-8')
        collectortype = hdcollector.nType
        collectordescription = hdcollector.szDescription.decode('utf-8')
        collectorextparam = hdcollector.szExtParam.decode('utf-8')
        collector_buf = Collector(collectorid, collectorname, collectortype, collectordescription, collectorextparam)

        return collector_buf

    def modify_collector(self, id, name, collectortype, description, extparam):
        if type(name) != str or type(collectortype) != int:
            raise TypeError
        if type(id) != int:
            raise TypeError
        if type(description) != str or type(extparam) != str:
            raise TypeError

        hdcollector = hyperdb.HD3Collector()
        hdcollector.nID = id
        hdcollector.szName = name.encode('utf-8')
        hdcollector.nType = collectortype
        hdcollector.szDescription = description.encode('utf-8')
        hdcollector.szExtParam = extparam.encode('utf-8')

        hyperdb.api.ct3_modify_collector.argtypes = [c_uint32, POINTER(hyperdb.HD3Collector)]
        retcode = hyperdb.api.ct3_modify_collector(id, byref(hdcollector))
        if hyperdb.hd_sucess != retcode:
            raise hyperdb.HDError(retcode)

        # !/usr/bin/env python

    ##ͨɼֲѯɼID
    # @param name ɼ
    # ʧܣ׳hyperdb.HDError쳣
    # @return hyperdb.hd_sucess
    def query_collector_id_by_name(self, name):
        if type(name) != str:
            raise TypeError

        collector_name = name.encode('utf-8')
        collector_id = c_uint32()
        hyperdb.api.ct3_query_collector_id_by_name.argtypes = [c_char_p, POINTER(c_uint32)]
        retcode = hyperdb.api.ct3_query_collector_id_by_name(collector_name, byref(collector_id))
        if hyperdb.hd_sucess != retcode:
            raise hyperdb.HDError(retcode)
        return collector_id

    ##ѯָɼ״̬
    # @param nnum ɼ
    # @param pcollectoridarray ɼid
    # ʧܣ׳hyperdb.HDError쳣
    # @return (retCode, status_array, err_array),status_array״̬
    # @noteɼ豸ԼɨҪɼܲѯɼ״̬
    def query_collectors_status(self, nnum, pcollectoridarray):
        if type(nnum) != int:
            raise TypeError
        if (nnum != len(pcollectoridarray)):
            raise hyperdb.HDParaError('invalid length of array')

        hd_nnum = c_int32(nnum)
        hd_pcollectoridarray = (nnum * c_uint32)()
        hd_pStatusArray = (nnum * hyperdb.HD3CtStatusInfo)()
        hd_pErrArray = (nnum * c_int32)()
        for index in range(nnum):
            hd_status_buf = hyperdb.HD3CtStatusInfo()
            hd_status_buf.nQuality = hyperdb.collector_nQuality_dict['HD3_QUALITY_CT_MIN']
            hd_status_buf.nTotalTagNum = 0
            hd_status_buf.nActiveTagNum = 0
            hd_pStatusArray[index] = hd_status_buf
            hd_pcollectoridarray[index] = pcollectoridarray[index]

        hyperdb.api.ct3_query_collectors_status.argtypes = [c_int32, POINTER(c_uint32), POINTER(hyperdb.HD3CtStatusInfo), POINTER(c_int32)]
        retCode = hyperdb.api.ct3_query_collectors_status(hd_nnum, hd_pcollectoridarray, hd_pStatusArray, hd_pErrArray)
        if hyperdb.hd_sucess != retCode and hyperdb.EC_HD_API_CT_QUERY_STATUS_INFO_FAILED != retCode:
            raise hyperdb.HDError(retCode)

        status_array = []
        err_array = []
        for status in hd_pStatusArray:
            status_array.append(status)
        for err in hd_pErrArray:
            err_array.append(err)

        return (retCode, status_array, err_array)

    ##²ɼ״̬
    # @param nCollectorID ɼid
    # @param nQuality ɼ״̬
    # @param nActiveTagNum ɼid
    # @param pTime ɼʱ(datetime  hyperdb.HD3Time)
    # ʧܣ׳hyperdb.HDError쳣
    # @return (retCode, status_array, err_array),status_array״̬
    def update_collector_status(self, nCollectorID, nQuality, nActiveTagNum, pTime):
        if type(nCollectorID) != int or type(nQuality) != int:
            raise TypeError
        if type(nActiveTagNum) != int:
            raise TypeError

        pTime_buf = hyperdb.HD3Time()
        collector_id = c_uint32(nCollectorID)
        quality = c_uint16(nQuality)
        active_tag_num = c_int32(nActiveTagNum)

        if True == isinstance(pTime, datetime):
            pTime_buf.nSec = c_int32(int(time.mktime(pTime.timetuple())))
            pTime_buf.nMsec = c_int16(int(pTime.microsecond / 1000))
        elif True == isinstance(pTime, hyperdb.HD3Time):
            pTime_buf.nSec = pTime.nSec
            pTime_buf.nMsec = pTime.nMsec
        else:
            raise ArgumentError

        hyperdb.api.ct3_update_collector_status.argtypes = [c_uint32, c_uint16, c_int32, POINTER(hyperdb.HD3Time)]
        retCode = hyperdb.api.ct3_update_collector_status(collector_id, quality, active_tag_num, byref(pTime_buf))
        if hyperdb.hd_sucess != retCode:
            raise hyperdb.HDError(retCode)

# -*- coding: gb2312 -*-

from ctypes import *
import hyperdb
import sys


class ScanGroup(object):
    def __init__(self):
        self.id = ''
        self.name = ''
        self.period = ''
        self.phase = ''
        self.scantype = ''
        self.deviceid = ''
        self.dataaddr = ''
        self.datalen = ''
        self.description = ''
        self.extparam = ''

class Device(object):
    def __init__(self, id, collectorid, name, addr, port, trytime, timeout, extparam, isprimary, description):
        self.id = id
        self.collectorid = collectorid
        self.name = name
        self.addr = addr
        self.port = port
        self.trytime = trytime
        self.timeout = timeout
        self.extparam = extparam
        self.isprimary = isprimary
        self.description = description

    def add_scan_group(self, name, period, phase, scantype, dataaddr, datalen, description, extparam):
        if type(period) != int or type(phase) != int:
            raise TypeError
        if type(scantype) != int or type(description) != str:
            raise TypeError
        if type(dataaddr) != int or type(datalen) != int:
            raise TypeError
        if type(name) != str or type(extparam) != str:
            raise TypeError

        sacn_group_name = name
        hdscangroup = hyperdb.HD3ScanGroup()
        hdscangroup.nID = 0
        hdscangroup.szName = sacn_group_name.encode('utf-8')
        hdscangroup.nPeriod = period
        hdscangroup.nPhase = phase
        hdscangroup.nScanType = scantype
        hdscangroup.nDeviceID = self.id
        hdscangroup.nDataAddr = dataaddr
        hdscangroup.nDataLen = datalen
        hdscangroup.szDescription = description.encode('utf-8')
        hdscangroup.szExtParam = extparam.encode('utf-8')

        scangroupid = c_uint32()

        hyperdb.api.ct3_add_scan_group.argtypes = [POINTER(hyperdb.HD3ScanGroup), POINTER(c_uint32)]
        retcode = hyperdb.api.ct3_add_scan_group(byref(hdscangroup), byref(scangroupid))
        if hyperdb.hd_sucess != retcode:
            raise hyperdb.HDError(retcode)

    def delete_scan_group(self, scangroupname):
        if type(scangroupname) != str:
            raise TypeError

        scan_group_name = scangroupname.encode('utf-8')
        device_id = c_uint32(self.id)
        group_id = c_uint32()
        hyperdb.api.ct3_query_scan_group_id_by_name.argtypes = [c_uint32, c_char_p, POINTER(c_uint32)]
        retcode = hyperdb.api.ct3_query_scan_group_id_by_name(device_id, scan_group_name, byref(group_id))
        if hyperdb.hd_sucess != retcode:
            raise hyperdb.HDError(retcode)

        hyperdb.api.ct3_delete_scan_group.argtypes = [c_uint32]
        retcode = hyperdb.api.ct3_delete_scan_group(group_id)
        if hyperdb.hd_sucess != retcode:
            raise hyperdb.HDError(retcode)

    def get_scan_groups(self):
        scangroup = hyperdb.HD3ScanGroup()
        hditer = c_void_p()
        device_id = c_uint32(self.id)

        hyperdb.api.ct3_query_scan_groups_of_device.argtypes = [c_uint32, POINTER(c_void_p)]
        retcode = hyperdb.api.ct3_query_scan_groups_of_device(device_id, byref(hditer))
        if hyperdb.hd_sucess != retcode:
            raise hyperdb.HDError(retcode)

        iterate = hyperdb.Iterate(hditer, scangroup)

        return iterate

    def get_scan_group(self, name):
        if type(name) != str:
            raise TypeError

        scan_group_name = name.encode('utf-8')
        device_id = c_uint32(self.id)
        group_id = c_uint32()
        hyperdb.api.ct3_query_scan_group_id_by_name.argtypes = [c_uint32, c_char_p, POINTER(c_uint32)]
        retcode = hyperdb.api.ct3_query_scan_group_id_by_name(device_id, scan_group_name, byref(group_id))
        if hyperdb.hd_sucess != retcode:
            raise hyperdb.HDError(retcode)

        hdscangroup = hyperdb.HD3ScanGroup()
        hyperdb.api.ct3_query_scan_group.argtypes = [c_uint32, POINTER(hyperdb.HD3ScanGroup)]
        retcode = hyperdb.api.ct3_query_scan_group(group_id, byref(hdscangroup))
        if hyperdb.hd_sucess != retcode:
            raise hyperdb.HDError(retcode)

        scangroup = ScanGroup()
        scangroup.id = hdscangroup.nID
        scangroup.name = hdscangroup.szName.decode('utf-8')
        scangroup.period = hdscangroup.nPeriod
        scangroup.phase = hdscangroup.nPhase
        scangroup.scantype = hdscangroup.nScanType
        scangroup.deviceid = hdscangroup.nDeviceID
        scangroup.dataaddr = hdscangroup.nDataAddr
        scangroup.datalen = hdscangroup.nDataLen
        scangroup.description = hdscangroup.szDescrption.decode('utf-8')
        scangroup.extparam = hdscangroup.szExtParam.decode('utf-8')

        return scangroup

    def modify_scan_group(self, id, name, period, phase, scantype, dataaddr, datalen, description, extparam):
        if type(period) != int or type(phase) != int:
            raise TypeError
        if type(scantype) != int or type(description) != str:
            raise TypeError
        if type(dataaddr) != int or type(datalen) != int:
            raise TypeError
        if type(name) != str or type(extparam) != str:
            raise TypeError
        if type(id) != int:
            raise TypeError

        scangroup = hyperdb.HD3ScanGroup()
        scangroup.nID = id
        scangroup.szName = name.encode('utf-8')
        scangroup.nPeriod = period
        scangroup.nPhase = phase
        scangroup.nScanType = scantype
        scangroup.nDeviceID = self.id
        scangroup.nDataAddr = dataaddr
        scangroup.nDataLen = datalen
        scangroup.szDescrption = description.encode('utf-8')
        scangroup.szExtParam = extparam.encode('utf-8')

        hyperdb.api.ct3_modify_scan_group.argtypes = [c_uint32, POINTER(hyperdb.HD3ScanGroup)]
        retcode = hyperdb.api.ct3_modify_scan_group(id, byref(scangroup))
        if hyperdb.hd_sucess != retcode:
            raise hyperdb.HDError(retcode)

    ##ͨɨֲѯɨID
    # @param name ɨ
    # ʧܣ׳hyperdb.HDError쳣
    # @return hyperdb.hd_sucess
    def query_scan_group_id_by_name(self, name):
        if type(name) != str:
            raise TypeError

        device_id = c_uint32(self.id)
        scan_group_name = name.encode('utf-8')
        scan_group_id = c_uint32()
        hyperdb.api.ct3_query_scan_group_id_by_name.argtypes = [c_uint32, c_char_p, POINTER(c_uint32)]
        retcode = hyperdb.api.ct3_query_scan_group_id_by_name(device_id, scan_group_name, byref(scan_group_id))
        if hyperdb.hd_sucess != retcode:
            raise hyperdb.HDError(retcode)
        return scan_group_id

class Collector(object):
    def __init__(self, id, name, type, description, extparam):
        # self.server = server
        self.id = id  # 豸ID
        self.name = name
        self.type = type
        self.description = description
        self.extparam = extparam

    def add_device(self, name, addr, port, trytime, timeout, extparam, isprimary, description):
        if type(description) != str or type(name) != str:
            raise TypeError
        if type(addr) != str or type(port) != int:
            raise TypeError
        if type(trytime) != int or type(timeout) != int:
            raise TypeError
        if type(extparam) != str or type(isprimary) != bool:
            raise TypeError

        device_name = name
        hddevice = hyperdb.HD3Device()
        hddevice.nID = 0
        hddevice.nCollectorID = self.id
        hddevice.szName = device_name.encode('utf-8')
        hddevice.szAddr = addr.encode('utf-8')
        hddevice.nPort = port
        hddevice.nTryTime = trytime
        hddevice.nTimeout = timeout
        hddevice.szExtParam = extparam.encode('utf-8')
        hddevice.bIsPrimary = isprimary
        hddevice.szDescription = description.encode('utf-8')

        deviceid = c_uint32()

        hyperdb.api.ct3_add_device.argtypes = [POINTER(hyperdb.HD3Device), POINTER(c_uint32)]
        retcode = hyperdb.api.ct3_add_device(byref(hddevice), byref(deviceid))

        if hyperdb.hd_sucess != retcode:
            raise hyperdb.HDError(retcode)

    def delete_device(self, name):
        if type(name) != str:
            raise TypeError

        device_name = name.encode('utf-8')
        collector_id = c_uint32(self.id)
        device_id = c_uint32()

        hyperdb.api.ct3_query_device_id_by_name.argtypes = [c_uint32, c_char_p, POINTER(c_uint32)]
        retcode = hyperdb.api.ct3_query_device_id_by_name(collector_id, device_name, byref(device_id))
        if hyperdb.hd_sucess != retcode:
            raise hyperdb.HDError(retcode)

        hyperdb.api.ct3_delete_device.argtypes = [c_uint32]
        retcode = hyperdb.api.ct3_delete_device(device_id)
        if hyperdb.hd_sucess != retcode:
            raise hyperdb.HDError(retcode)

    ##ֻȡ豸
    # @param name 
    # ʧܣ׳hyperdb.HDError쳣
    # @return 豸Ķ
    def get_device(self, name):
        if type(name) != str:
            raise TypeError

        device_name = name.encode('utf-8')
        device_id = c_uint32()
        collector_id = c_uint32(self.id)

        hyperdb.api.ct3_query_device_id_by_name.argtypes = [c_uint32, c_char_p, POINTER(c_uint32)]
        retcode = hyperdb.api.ct3_query_device_id_by_name(collector_id, device_name, byref(device_id))
        if hyperdb.hd_sucess != retcode:
            raise hyperdb.HDError(retcode)

        hddevice = hyperdb.HD3Device()
        hyperdb.api.ct3_query_device.argtypes = [c_uint32, POINTER(hyperdb.HD3Device)]
        retcode = hyperdb.api.ct3_query_device(device_id, byref(hddevice))
        if hyperdb.hd_sucess != retcode:
            raise hyperdb.HDError(retcode)

        device_id = hddevice.nID
        device_collectorid = hddevice.nCollectorID
        device_name = hddevice.szName.decode('utf-8')
        device_addr = hddevice.szAddr.decode('utf-8')
        device_port = hddevice.nPort
        device_trytime = hddevice.nTryTime
        device_timeout = hddevice.nTimeout
        device_extparam = hddevice.szExtParam.decode('utf-8')
        device_isprimary = hddevice.bIsPrimary
        device_description = hddevice.szDescription.decode('utf-8')

        device_buf = Device(device_id, device_collectorid, device_name, device_addr, device_port,
                            device_trytime, device_timeout, device_extparam, device_isprimary, device_description)

        return device_buf

    def get_all_devices(self):
        hddevice = hyperdb.HD3Device()
        hditer = c_void_p()

        hyperdb.api.ct3_query_devices_of_collector.argtypes = [c_uint32, POINTER(c_void_p)]
        retcode = hyperdb.api.ct3_query_devices_of_collector(self.id, byref(hditer))
        if hyperdb.hd_sucess != retcode:
            raise hyperdb.HDError(retcode)

        iterate = hyperdb.Iterate(hditer, hddevice)

        return iterate

    def modify_device(self, id, name, addr, port, trytime, timeout, extparam, isprimary, description):
        if type(description) != str or type(name) != str:
            raise TypeError
        if type(addr) != str or type(port) != int:
            raise TypeError
        if type(trytime) != int or type(timeout) != int:
            raise TypeError
        if type(extparam) != str or type(isprimary) != bool:
            raise TypeError
        if type(id) != int:
            raise TypeError

        hddevice = hyperdb.HD3Device()
        hddevice.nID = id
        hddevice.nCollectorID = self.id
        hddevice.szName = name.encode('utf-8')
        hddevice.szAddr = addr.encode('utf-8')
        hddevice.nPort = port
        hddevice.nTryTime = trytime
        hddevice.nTimeout = timeout
        hddevice.szExtParam = extparam.encode('utf-8')
        hddevice.bIsPrimary = isprimary
        hddevice.szDescription = description.encode('utf-8')

        hyperdb.api.ct3_modify_device.argtypes = [c_uint32, POINTER(hyperdb.HD3Device)]
        retcode = hyperdb.api.ct3_modify_device(id, byref(hddevice))
        if hyperdb.hd_sucess != retcode:
            raise hyperdb.HDError(retcode)

    ##ͨ豸ֲѯ豸ID
    # @param name 豸
    # ʧܣ׳hyperdb.HDError쳣
    # @return hyperdb.hd_sucess
    def query_device_id_by_name(self, name):
        if type(name) != str:
            raise TypeError

        device_name = name.encode('utf-8')
        device_id = c_uint32()
        collector_id = c_uint32(self.id)
        hyperdb.api.ct3_query_device_id_by_name.argtypes = [c_uint32, c_char_p, POINTER(c_uint32)]
        retcode = hyperdb.api.ct3_query_device_id_by_name(collector_id, device_name, byref(device_id))
        if hyperdb.hd_sucess != retcode:
            raise hyperdb.HDError(retcode)
        return device_id

    ##ѯָ豸״̬
    # @param nnum ɼ
    # @param pdeviceidarray 豸id
    # ʧܣ׳hyperdb.HDError쳣
    # @return (retCode, status_array, err_array),status_array״̬
    # @noteɼ豸ԼɨҪɼܲѯɼ״̬
    def query_devices_status(self, nnum, pdeviceidarray):
        if type(nnum) != int:
            raise TypeError
        if (nnum != len(pdeviceidarray)):
            raise hyperdb.HDParaError('invalid length of array')

        hd_nnum = c_int32(nnum)
        hd_pdeviceidarray = (nnum * c_uint32)()
        hd_pStatusArray = (nnum * hyperdb.HD3CtStatusInfo)()
        hd_pErrArray = (nnum * c_int32)()
        for index in range(nnum):
            hd_status_buf = hyperdb.HD3CtStatusInfo()
            hd_status_buf.nQuality = hyperdb.device_nQuality_dict['HD3_QUALITY_DEVICE_MIN']
            hd_status_buf.nTotalTagNum = 0
            hd_status_buf.nActiveTagNum = 0
            hd_pStatusArray[index] = hd_status_buf
            hd_pdeviceidarray[index] = pdeviceidarray[index]

        hyperdb.api.ct3_query_devices_status.argtypes = [c_int32, POINTER(c_uint32),
                                                            POINTER(hyperdb.HD3CtStatusInfo), POINTER(c_int32)]
        retCode = hyperdb.api.ct3_query_devices_status(hd_nnum, hd_pdeviceidarray, hd_pStatusArray, hd_pErrArray)
        if hyperdb.hd_sucess != retCode and hyperdb.EC_HD_API_CT_QUERY_STATUS_INFO_FAILED != retCode:
            raise hyperdb.HDError(retCode)

        status_array = []
        err_array = []
        for status in hd_pStatusArray:
            status_array.append(status)
        for err in hd_pErrArray:
            err_array.append(err)

        return (retCode, status_array, err_array)

    ##豸״̬
    # @param nDeviceID 豸id
    # @param nQuality 豸״̬
    # @param nActiveTagNum 豸id
    # @param pTime 豸ʱ(datetime  hyperdb.HD3Time)
    # ʧܣ׳hyperdb.HDError쳣
    # @return (retCode, status_array, err_array),status_array״̬
    def update_device_status(self, nDeviceID, nQuality, nActiveTagNum, pTime):
        if type(nDeviceID) != int or type(nQuality) != int:
            raise TypeError
        if type(nActiveTagNum) != int:
            raise TypeError

        pTime_buf = hyperdb.HD3Time()
        device_id = c_uint32(nDeviceID)
        quality = c_uint16(nQuality)
        active_tag_num = c_int32(nActiveTagNum)

        if True == isinstance(pTime, datetime):
            pTime_buf.nSec = c_int32(int(time.mktime(pTime.timetuple())))
            pTime_buf.nMsec = c_int16(int(pTime.microsecond / 1000))
        elif True == isinstance(pTime, hyperdb.HD3Time):
            pTime_buf.nSec = pTime.nSec
            pTime_buf.nMsec = pTime.nMsec
        else:
            raise ArgumentError

        hyperdb.api.ct3_update_device_status.argtypes = [c_uint32, c_uint16, c_int32, POINTER(hyperdb.HD3Time)]
        retCode = hyperdb.api.ct3_update_device_status(device_id, quality, active_tag_num, byref(pTime_buf))
        if hyperdb.hd_sucess != retCode:
            raise hyperdb.HDError(retCode)
