#!/usr/bin/env python
# -*- coding: gb2312 -*-
import os
import random
import sys
import time
from datetime import date

sys.path.append(".")
import server, security, record, dataprovider, hdUser, usergroupmgr


class TestSDK:
    def ConnectServer(self, username, password):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login(username, password)
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider
        self.myUsergroupMgr = usergroupmgr.UserGroupMgr()

    def AddTrust(self):
        trust_name = ['haha', 'heihei']
        trust_startip = ['127.0.0.1', '127.0.0.122']
        trust_endip = ['127.0.0.121', '127.0.0.222']
        trust_username = ['admin', 'admin']
        try:
            self.myServer.security_mgr.add_trust(name=trust_name[0], startip=trust_startip[0],
                                                 endip=trust_endip[0], username=trust_username[0])
            self.myServer.security_mgr.add_trust(name=trust_name[1], startip=trust_startip[1],
                                                 endip=trust_endip[1], username=trust_username[1])
        except Exception as e:
            print("add_trust error: ", e.errcode)
        else:
            print("adding trust succeeds")

    def GetAllTrust(self):
        try:
            ret_iter = self.myServer.security_mgr.get_all_trusts()
        except Exception as e:
            print("get_all_trusts error: ", e.errcode)
        else:
            print("getting all trusts succeeds")
            while True:
                trust_rec = ret_iter.get_next()
                if trust_rec is None:
                    break
                else:
                    print("The trust' name : ", trust_rec.name,
                        "The trust' start_ip : ", trust_rec.start_ip,
                        "The trust' end_ip : ", trust_rec.end_ip,
                        "The trust' user_name : ", trust_rec.user_name)

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")

if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")
    testA.ConnectServer(username='admin', password='admin')
    time.sleep(20)
    testA.AddTrust()
    time.sleep(20)
    testA.GetAllTrust()
    time.sleep(20)
    testA.Disconnet()

