#!/usr/bin/env python
# -*- coding: gb2312 -*-
import ctypes
import datetime
import os
import random
import sys
import time
from datetime import date

sys.path.append("Tag")
import server, security, record, dataprovider


class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider

    def AddTags(self):
        attr = [{'tagname': 'tag_int16_10', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_11', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_12', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_13', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_14', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_15', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_16', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_17', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_18', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_19', 'tagtype': 'int8'}]
        try:
            self.myTagMgr.add_tags(attr)
        except Exception as e:
            print("add_tags error: ", e.errcode)
        else:
            print("adding tags succeeds")

    def SaveSnapshots(self):
        tagname = "tag_int16_10"
        tagnames = []
        time_stamp = []
        hdrecord_list = []
        snapshot_list = []
        try:
            self.myTag = self.myTagMgr.get_tag(tagname)
        except Exception as e:
            print(e)
        for minute in range(10, 15):
            for sec in [0, 10, 20, 30, 40, 50]:
                time_rec = "2023-10-16 15:" + str(minute) + ":" + str(sec)
                # תΪʱ
                time_rec = time.strptime(time_rec, "%Y-%m-%d %H:%M:%S")
                # תΪʱ
                time_stamp.append(int(time.mktime(time_rec)))
        len_time_stamp = len(time_stamp)
        for i in range(len_time_stamp):
            tagnames.append(tagname)
        try:
            ret = self.myTagMgr.get_tagIDs(tagnames)
        except Exception as e:
            print("get_tagIDs error: ", e.errcode)

        for i in range(len_time_stamp):
            hdrecord = record.Record(time_stamp[i], 0)
            hdrecord.tagtype = self.myTag.tagtype
            hdrecord.quality = 192
            hdrecord.value = random.randint(0, 10)
            hdrecord_list.append(hdrecord)

        for i in range(len_time_stamp):
            snapshot_list.append((ret[1][i], hdrecord_list[i]))
        try:
            self.myTag.save_snapshots(snapshot_list)
        except Exception as e:
            print("save_snapshots error: ", e.errcode)
        else:
            print("saving snapshots succeeds")

    def GetInterRecordByMode(self):
        tagname = 'tag_int16_10'
        try:
            self.myTag = self.myTagMgr.get_tag(tagname)
        except Exception as e:
            print(e)
        self.dattime = datetime.datetime(2023, 10, 16, 15, 10, 35, 0)

        try:
            ## mode0/1  ->  LINEAR/PREV
            hdrecord = self.myTag.get_inter_record_by_mode(0, timestamp=self.dattime)
        except Exception as e:
            print("get_inter_record_by_mode error: ", e.errcode)
            time.sleep(10)
            try:
                ## mode0/1  ->  LINEAR/PREV
                hdrecord = self.myTag.get_inter_record_by_mode(0, timestamp=self.dattime)
            except Exception as e:
                print("get_inter_record_by_mode error: ", e.errcode)
                time.sleep(10)
                try:
                    ## mode0/1  ->  LINEAR/PREV
                    hdrecord = self.myTag.get_inter_record_by_mode(0, timestamp=self.dattime)
                except Exception as e:
                    print("get_inter_record_by_mode error: ", e.errcode)
                else:
                    print("getting inter_record_by_mode succeeds")
                    print("snapshot quality: ", hdrecord.quality, "snapshot value: ", hdrecord.value, ", timestamp: ",
                          hdrecord.sec)
            else:
                print("getting inter_record_by_mode succeeds")
                print("snapshot quality: ", hdrecord.quality, "snapshot value: ", hdrecord.value, ", timestamp: ",
                      hdrecord.sec)
        else:
            print("getting inter_record_by_mode succeeds")
            print("snapshot quality: ", hdrecord.quality, "snapshot value: ", hdrecord.value, ", timestamp: ",
                  hdrecord.sec)

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")

if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")

    testA.ConnectServer()
    time.sleep(15)
    testA.AddTags()
    time.sleep(15)
    testA.SaveSnapshots()
    time.sleep(15)
    testA.GetInterRecordByMode()
    time.sleep(15)
    testA.Disconnet()

