#!/usr/bin/env python
# -*- coding: gb2312 -*-
import os
import random
import sys
import time
from datetime import date

sys.path.append(".")
import server, security, record, dataprovider, hdUser, usergroupmgr


class TestSDK:
    def ConnectServer(self, username, password):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login(username, password)
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider
        self.myUsergroupMgr = usergroupmgr.UserGroupMgr()

    def AddGroup(self, name):
        try:
            self.myUsergroupMgr.add_group(name=name, desc='administer',)
        except Exception as e:
            print("add_group error: ", e.errcode)
        else:
            print("adding group succeeds")

    def AddUser(self, name, password, description):
        try:
            self.myUsergroupMgr.add_user(name=name, psw=password, desc=description)
        except Exception as e:
            print("add_user error: ", e.errcode)
        else:
            print("adding user succeeds")

    def AddGroupMembership(self, group_name):
        self.myhdUser = hdUser.User(name='haha', desc='haha')
        try:
            self.myhdUser.add_group_membership(groupname=group_name)
        except Exception as e:
            print("add_group_membership error: ", e.errcode)
        else:
            print("adding group membership succeeds")

    def GetMemberGroups(self):
        self.myhdUser = hdUser.User(name='haha', desc='haha')
        try:
            ret = self.myhdUser.get_member_groups()
        except Exception as e:
            print("get_member_groups error: ", e.errcode)
        else:
            print("getting member groups succeeds")
            while True:
                mem_group = ret.get_next()
                if mem_group is None:
                    break
                else:
                    print("The member group is :", mem_group.name)

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")


if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")
    testA.ConnectServer(username='admin', password='admin')
    time.sleep(20)
    testA.AddGroup(name='administer')
    time.sleep(20)
    testA.AddUser(name='haha', password='admin', description='haha')
    time.sleep(20)
    testA.AddGroupMembership(group_name='administer')
    time.sleep(20)
    testA.GetMemberGroups()
    time.sleep(20)
    testA.Disconnet()

