#!/usr/bin/env python
# -*- coding: gb2312 -*-
import datetime
import os
import random
import sys
import time
from datetime import date

sys.path.append("Tag")
import server, security, record, dataprovider, tag


class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider
        self.myTag = tag.Tag()

    def AddTag(self):
        attr = {'tagname': 'int8', 'tagtype': 'int8'}
        try:
            self.myTagMgr.add_tag(**attr)
        except Exception as e:
            print("add_tag error: ", e.errcode)
        else:
            print("adding tag succeeds")

    def AddAlarmTags(self):
        props = [{'tagname': 'amtag0',
                      'tagtype': 'int32',
                      'sourcetagname': 'int8',
                  'descriptor': 'yayaya'
                     },{'tagname': 'amtag1',
                      'tagtype': 'int32',
                      'sourcetagname': 'int8',
                    'descriptor': 'rrrrr'
                     }]
        try:
            tagalarmids = self.myTagMgr.add_alarm_tags(props=props)
        except Exception as e:
            print("add_alarm_tags error: ", e.errcode)
        else:
            print("adding alarm tags succeeds")

    def ModifyAlarmTagsAttributes(self):
        props = [{'tagname': 'amtag0', 'descriptor': 'hahaha'},
                 {'tagname': 'amtag1', 'descriptor': 'aaaaaa'}]
        tagnames = ['amtag0', 'amtag1']
        try:
            tag1 = self.myTagMgr.get_tag(tagname=tagnames[0])
        except Exception as e:
            print("get_tag error: ", e.errcode)
        else:
            print("tagname: ", tag1.tagname, "descriptor: ", tag1.descriptor)
        try:
            tag2 = self.myTagMgr.get_tag(tagname=tagnames[1])
        except Exception as e:
            print("get_tag error: ", e.errcode)
        else:
            print("tagname: ", tag2.tagname, "descriptor: ", tag2.descriptor)
        try:
            self.myTagMgr.modify_alarm_tags_attributes(props=props)
        except Exception as e:
            print("modify_alarm_tags_attributes error: ", e.errcode)
        else:
            print("modifying alarm tags' attributes succeeds")
        try:
            tag1 = self.myTagMgr.get_tag(tagname=tagnames[0])
        except Exception as e:
            print("get_tag error: ", e.errcode)
        else:
            print("tagname: ", tag1.tagname, "descriptor: ", tag1.descriptor)
        try:
            tag2 = self.myTagMgr.get_tag(tagname=tagnames[1])
        except Exception as e:
            print("get_tag error: ", e.errcode)
        else:
            print("tagname: ", tag2.tagname, "descriptor: ", tag2.descriptor)

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")

if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")

    testA.ConnectServer()
    time.sleep(20)
    testA.AddTag()
    time.sleep(20)
    testA.AddAlarmTags()
    time.sleep(20)
    testA.ModifyAlarmTagsAttributes()
    time.sleep(20)
    testA.Disconnet()
