#!/usr/bin/env python
# -*- coding: gb2312 -*-
import datetime
import os
import random
import sys
import time
from datetime import date

sys.path.append("Tag")
import server, security, record, dataprovider, tag


class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider
        self.myTag = tag.Tag()

    def AddTag(self):
        attr = {'tagname': 'srctag', 'tagtype': 'int8'}
        try:
            self.myTagMgr.add_tag(**attr)
        except Exception as e:
            print("add_tag error: ", e.errcode)
        else:
            print("adding tag succeeds")

    def AddCalcTags(self):
        props = [{'tagname': 'catag0',
                      'tagtype': 'int32',
                      'szCalcExpr': '\'srctag\'+1',
                     'szSourceTagName':'srctag',
                     'nCalcMode' : 0,
                     'nCalcPeriod' :5,
                     'descriptor': '123'
                     },{'tagname': 'catag1',
                      'tagtype': 'int32',
                      'szCalcExpr': '\'srctag\'+1',
                     'szSourceTagName':'srctag',
                     'nCalcMode' : 0,
                     'nCalcPeriod' :5,
                    'descriptor': '234'
                     }]
        try:
            tagcalcids = self.myTagMgr.add_calc_tags(props=props)
        except Exception as e:
            print("add_calc_tags error: ", e.errcode)
        else:
            print("adding calc tags succeeds")

    def ModifyCalcTagAttributes(self):
        props = [{'tagname':'catag0',
                       'nCalcPeriod' :6,
                       'szCalcExpr': '\'srctag\'+2',
                       'descriptor':'123321'
                       },
                      {'tagname':'catag1',
                       'nCalcPeriod' :7,
                       'szCalcExpr': '\'srctag\'+3',
                       'descriptor':'234432'
                       }]

        tagnames = ['catag0', 'catag1']
        try:
            tag1 = self.myTagMgr.get_tag(tagname=tagnames[0])
        except Exception as e:
            print("get_tag error: ", e.errcode)
        else:
            print("tagname: ", tag1.tagname, "descriptor: ", tag1.descriptor)
        try:
            tag2 = self.myTagMgr.get_tag(tagname=tagnames[1])
        except Exception as e:
            print("get_tag error: ", e.errcode)
        else:
            print("tagname: ", tag2.tagname, "descriptor: ", tag2.descriptor)
        try:
            self.myTagMgr.modify_calc_tag_attributes(props=props)
        except Exception as e:
            print("modify_calc_tag_attributes error: ", e.errcode)
        else:
            print("modifying calc tags' attributes succeeds")
        try:
            tag1 = self.myTagMgr.get_tag(tagname=tagnames[0])
        except Exception as e:
            print("get_tag error: ", e.errcode)
        else:
            print("tagname: ", tag1.tagname, "descriptor: ", tag1.descriptor)
        try:
            tag2 = self.myTagMgr.get_tag(tagname=tagnames[1])
        except Exception as e:
            print("get_tag error: ", e.errcode)
        else:
            print("tagname: ", tag2.tagname, "descriptor: ", tag2.descriptor)

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")

if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")

    testA.ConnectServer()
    time.sleep(15)
    testA.AddTag()
    time.sleep(15)
    testA.AddCalcTags()
    time.sleep(15)
    testA.ModifyCalcTagAttributes()
    time.sleep(15)
    testA.Disconnet()
