#!/usr/bin/env python
# -*- coding: gb2312 -*-
import os
import random
import sys
import time
from datetime import date

sys.path.append(".")
import server, security, record, dataprovider, hdUser, usergroupmgr, alarmgroupmgr, alarmgroup


class TestSDK:
    def ConnectServer(self, username, password):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login(username, password)
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider
        self.myUsergroupMgr = usergroupmgr.UserGroupMgr()
        self.myAlarmGroupMgr = alarmgroupmgr.AlarmGroupMgr()


    def AddAlarmGroup(self):
        name_alG = ['ha', 'haha', 'hei', 'heihei']
        desc_alG = ['ha', 'haha', 'hei', 'heihei']
        parentid_alG = [0, 1, 0, 1]
        try:
            for i in range(4):
                self.myAlarmGroupMgr.add_alarmgroup(name=name_alG[i], desc=desc_alG[i], parentid=parentid_alG[i])
        except Exception as e:
            print("add_alarmgroup error: ", e.errcode)
        else:
            print("adding alarm group succeeds")

    def GetAlarmChildgroups(self, name_aCg = 'default', id_aCg = 1, desc_aCCg = 'default', pID_aCg = 0):
        alCG_name = []
        alCG_description = []
        alCG_id = []
        alCG_parentid = []
        self.myAlarmGroup = alarmgroup.AlarmGroup(name=name_aCg,
                                                  id=id_aCg,
                                                  description=desc_aCCg,
                                                  parentid=pID_aCg)
        try:
            iter_alCGs = self.myAlarmGroup.get_alarm_childgroups()
        except Exception as e:
            print("get_alarm_childgroups error: ", e.errcode)
        else:
            print("getting alarm child groups succeeds")
            while True:
                alCG = iter_alCGs.get_next()
                if alCG is None:
                    break
                else:
                    print("The alarm group' name: ", alCG.name, "\t"
                          "The alarm group' description: ", alCG.description, "\t"
                          "The alarm group' id: ", alCG.id, "\t"
                          "The alarm group' parentid: ", alCG.parentid)
                    alCG_name.append(alCG.name)
                    alCG_description.append(alCG.description)
                    alCG_id.append(alCG.id)
                    alCG_parentid.append(alCG.parentid)
        return alCG_name, alCG_description, alCG_id, alCG_parentid

    def ModifyParentgroup(self, alCG_name, alCG_description, alCG_id, alCG_parentid):
        newPgid_alG = alCG_id[1]
        self.myAlarmGroup = alarmgroup.AlarmGroup(name=alCG_name[0],
                                                  id=alCG_id[0],
                                                  description=alCG_description[0],
                                                  parentid=alCG_parentid[0])
        try:
            self.myAlarmGroup.modify_parentgroup(parentid=newPgid_alG)
        except Exception as e:
            print("modify_parentgroup error: ", e.errcode)
        else:
            print("modifying parentgroup succeeds")

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")

if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")
    testA.ConnectServer(username='admin', password='admin')
    time.sleep(20)
    testA.AddAlarmGroup()
    time.sleep(20)
    alCG_name, alCG_description, alCG_id, alCG_parentid = testA.GetAlarmChildgroups()
    time.sleep(20)
    testA.ModifyParentgroup(alCG_name, alCG_description, alCG_id, alCG_parentid)
    time.sleep(20)
    alCG_name, alCG_description, alCG_id, alCG_parentid = testA.GetAlarmChildgroups(name_aCg = alCG_name[1], id_aCg = alCG_id[1], desc_aCCg = alCG_description[1], pID_aCg = alCG_parentid[1])
    time.sleep(20)
    testA.Disconnet()

