#!/usr/bin/env python
# -*- coding: gb2312 -*-
import datetime
import os
import random
import sys
import time
from datetime import date

sys.path.append("Tag")
import server, security, record, dataprovider, tag


class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider
        self.myTag = tag.Tag()

    def AddTag(self):
        attr = {'tagname': 'srctag', 'tagtype': 'int8'}
        try:
            self.myTagMgr.add_tag(**attr)
        except Exception as e:
            print("add_tag error: ", e.errcode)
        else:
            print("adding tag succeeds")
    def AddStatsTags(self):
        props = [{'tagname': 'sttag0',
                      'tagtype': 'float64',
                     'szSourceTagName':'srctag',
                     'nSampleStartDate': 0,
                     'nSampleInterval':10,
                     'nSampleMode':0,
                     'nStatsType': 0,
                     'nCalcPeriod':1,
                     'nScanPeriod':10,
                     'nSampleType':0,
                     'nSampleStartDate':1
                     },{'tagname': 'sttag1',
                      'tagtype': 'float64',
                     'szSourceTagName':'srctag',
                     'nSampleStartDate': 0,
                     'nSampleInterval':10,
                     'nSampleMode':0,
                     'nStatsType': 0,
                     'nCalcPeriod':2,
                     'nScanPeriod':10,
                     'nSampleType':0,
                     'nSampleStartDate':1
                     }]
        try:
            tagids = self.myTagMgr.add_stats_tags(props=props)
        except Exception as e:
            print("add_stats_tags error: ", e.errcode)
        else:
            print("adding stats tags succeeds")

    def GetTag(self):
        try:
            tag0 = self.myTagMgr.get_tag(tagname='sttag0')
        except Exception as e:
            print("add_stats_tags error: ", e.errcode)
        else:
            print("tagname: ", tag0.tagname, "tagclass: ", tag0.tagclass)
        try:
            tag1 = self.myTagMgr.get_tag(tagname='sttag1')
        except Exception as e:
            print("add_stats_tags error: ", e.errcode)
        else:
            print("tagname: ", tag1.tagname, "tagclass: ", tag1.tagclass)

    def ModifyStatsTagAttributes(self):
        props = [{'tagname': 'sttag0', 'descriptor': '123'},
                 {'tagname': 'sttag1', 'descriptor': '234'}]

        tagnames = ['sttag0', 'sttag1']
        try:
            tag1 = self.myTagMgr.get_tag(tagname=tagnames[0])
        except Exception as e:
            print("get_tag error: ", e.errcode)
        else:
            print("tagname: ", tag1.tagname, "descriptor: ", tag1.descriptor)
        try:
            tag2 = self.myTagMgr.get_tag(tagname=tagnames[1])
        except Exception as e:
            print("get_tag error: ", e.errcode)
        else:
            print("tagname: ", tag2.tagname, "descriptor: ", tag2.descriptor)
        try:
            self.myTagMgr.modify_stats_tag_attributes(props=props)
        except Exception as e:
            print("modify_stats_tag_attributes error: ", e.errcode)
        else:
            print("modifying stats tags' attributes succeeds")
        try:
            tag1 = self.myTagMgr.get_tag(tagname=tagnames[0])
        except Exception as e:
            print("get_tag error: ", e.errcode)
        else:
            print("tagname: ", tag1.tagname, "descriptor: ", tag1.descriptor)
        try:
            tag2 = self.myTagMgr.get_tag(tagname=tagnames[1])
        except Exception as e:
            print("get_tag error: ", e.errcode)
        else:
            print("tagname: ", tag2.tagname, "descriptor: ", tag2.descriptor)

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")

if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")

    testA.ConnectServer()
    time.sleep(15)
    testA.AddTag()
    time.sleep(15)
    testA.AddStatsTags()
    time.sleep(15)
    testA.ModifyStatsTagAttributes()
    time.sleep(15)
    testA.Disconnet()
