#!/usr/bin/env python
# -*- coding: gb2312 -*-
import os
import random
import sys
import time
from datetime import date

sys.path.append(".")
import server, security, record, dataprovider, hdUser, usergroupmgr


class TestSDK:
    def ConnectServer(self, username, password):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login(username, password)
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider
        self.myUsergroupMgr = usergroupmgr.UserGroupMgr()

    def AddGroup(self, name):
        try:
            self.myUsergroupMgr.add_group(name=name, desc='administer',)
        except Exception as e:
            print("add_group error: ", e.errcode)
        else:
            print("adding group succeeds")

    def AddUser(self, name, password, description):
        try:
            self.myUsergroupMgr.add_user(name=name, psw=password, desc=description)
        except Exception as e:
            print("add_user error: ", e.errcode)
        else:
            print("adding user succeeds")

    def AddGroupMembership(self, group_name):
        self.myhdUser = hdUser.User(name='haha', desc='haha')
        try:
            self.myhdUser.add_group_membership(groupname=group_name)
        except Exception as e:
            print("add_group_membership error: ", e.errcode)
        else:
            print("adding group membership succeeds")

    def ModifyTagSecurity(self):
        try:
            ret_secitem_org = self.myServer.security_mgr.get_tag_security()
        except Exception as e:
            print("getting tag security error: ", e.errcode)
        else:
            print("getting tag security succeeds")
            print("tag security' owngroupname:", ret_secitem_org.owngroupname,
                  "tag security' operategroupname:", ret_secitem_org.operategroupname,
                  "tag security' securitylevel:", ret_secitem_org.securitylevel)
        ret_secitem_mdf = security.Security(owngroupname='admin', operategroupname='administer', securitylevel=53)
        try:
            self.myServer.security_mgr.modify_tag_security(secitem=ret_secitem_mdf)
        except Exception as e:
            print("modify_tag_security error: ", e.errcode)
        else:
            print("modifying tag security succeeds")
        try:
            ret_secitem = self.myServer.security_mgr.get_tag_security()
        except Exception as e:
            print("getting tag security error: ", e.errcode)
        else:
            print("getting tag security succeeds")
            print("tag security' owngroupname:", ret_secitem.owngroupname,
                  "tag security' operategroupname:", ret_secitem.operategroupname,
                  "tag security' securitylevel:", ret_secitem.securitylevel)

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")

if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")
    testA.ConnectServer(username='admin', password='admin')
    time.sleep(20)
    testA.AddGroup(name='administer')
    time.sleep(20)
    testA.AddUser(name='haha', password='admin', description='haha')
    time.sleep(20)
    testA.AddGroupMembership(group_name='administer')
    time.sleep(20)
    testA.ModifyTagSecurity()
    time.sleep(20)
    testA.Disconnet()

