import sys
import time
from datetime import date
import threading

sys.path.append(".")
import server,security, record, dataprovider

class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()   
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider
        
        
    def QuerySnapShots1(self):
        tagnames = {}
        for i in range(100):
            tagnames[i] = 'tag_int32_' + str(i)
        try:
            ret = self.myTagMgr.get_tagIDs(tagnames)
        except Exception as e:
            print("get_tagIDs error: ", e.errcode)

        try:
            res = self.myDateProvider.get_snapshot_by_IDs(ret[1])
        except Exception as e:
            print("get_snapshot_by_IDs error: ", e.errcode)
        else:
            for i in range(100):
                print("tagname: ", tagnames[i] ,"snapshot value: ", res[1][i].value)

    def QuerySnapShots2(self):
        tagnames = {}
        for i in range(100):
            tagnames[i] = 'tag_int32_100' + str(i)
        try:
            ret = self.myTagMgr.get_tagIDs(tagnames)
        except Exception as e:
            print("get_tagIDs error: ", e.errcode)

        try:
            res = self.myDateProvider.get_snapshot_by_IDs(ret[1])
        except Exception as e:
            print("get_snapshot_by_IDs error: ", e.errcode)
        else:
            for i in range(100):
                print("tagname: ", tagnames[i] ,"snapshot value: ", res[1][i].value)

    def Disconnet(self):
        self.myServer.disconnect()
        
if __name__ == '__main__':
    testA = TestSDK()    
    print("PythonSDK_V3 mutithreadsample..")
    
    testA.ConnectServer()
    thread1 = threading.Thread(target= testA.QuerySnapShots1())
    thread2 = threading.Thread(target= testA.QuerySnapShots2())
    thread1.start()   
    thread2.start()
    thread1.join()
    thread2.join()
    print("mutithread finish")
    testA.Disconnet()
    