#!/usr/bin/env python
# -*- coding: gb2312 -*-
import datetime
import os
import random
import sys
import time
from datetime import date

sys.path.append("Tag")
import server, security, record, dataprovider, tag


class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider
        self.myTag = tag.Tag()

    def AddTag(self):
        attr = {'tagname': 'int8', 'tagtype': 'int8'}
        try:
            self.myTagMgr.add_tag(**attr)
        except Exception as e:
            print("add_tag error: ", e.errcode)
        else:
            print("adding tag succeeds")

    def AddAlarmTags(self):
        props = [{'tagname': 'amtag0',
                      'sourcetagname': 'int8'
                     },{'tagname': 'amtag1',
                      'sourcetagname': 'int8'
                     }]
        try:
            tagalarmids = self.myTagMgr.add_alarm_tags(props=props)
        except Exception as e:
            print("add_alarm_tags error: ", e.errcode)
        else:
            print("adding alarm tags succeeds")

    def QueryAlarmTagsCond(self):
        conds = [('tagname', 'like', '*tag*')]
        try:
            ret = self.myTagMgr.query_alarm_tags_cond(conds=conds)
        except Exception as e:
            print("query_alarm_tags_cond error", e.errcode)
        else:
            print("querying alarm tags by conditions succeeds")
            while True:
                hdrec = ret.get_next()
                if hdrec is None:
                    break
                else:
                    print("tag's name: ", hdrec.tagname)

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")

if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")

    testA.ConnectServer()
    time.sleep(20)
    testA.AddTag()
    time.sleep(20)
    testA.AddAlarmTags()
    time.sleep(20)
    testA.QueryAlarmTagsCond()
    time.sleep(20)
    testA.Disconnet()
