#!/usr/bin/env python
# -*- coding: gb2312 -*-
import os
import random
import sys
import time
from datetime import date

sys.path.append("")
import server, security, record, dataprovider


class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider

    def AddTags(self):
        attr = [{'tagname': 'tag_int16_10', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_11', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_12', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_13', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_14', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_15', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_16', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_17', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_18', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_19', 'tagtype': 'int8'}]
        try:
            self.myTagMgr.add_tags(attr)
        except Exception as e:
            print("add_tags error: ", e.errcode)
        else:
            print("adding tags succeeds")

    def SaveSnapshots(self):
        tagnames = []
        hdrecord_list = []
        snapshot_list = []
        for i in range(10, 20):
            tagnames.append('tag_int16_' + str(i))
        for tagname in tagnames:
            try:
                self.myTag = self.myTagMgr.get_tag(tagname)
            except Exception as e:
                print(e)
            hdrecord = record.Record(int(time.strftime('%m%d%H%M%S', time.localtime())), 0)
            hdrecord.tagtype = self.myTag.tagtype
            hdrecord.quality = 192
            hdrecord.value = random.randint(0, 10)
            hdrecord_list.append(hdrecord)
        try:
            ret = self.myTagMgr.get_tagIDs(tagnames)
        except Exception as e:
            print("get_tagIDs error: ", e.errcode)
        for i in range(10):
            snapshot_list.append((ret[1][i], hdrecord_list[i]))
        try:
            self.myTag.save_snapshots(snapshot_list)
        except Exception as e:
            print("save_snapshots error: ", e.errcode)
        else:
            print("saving snapshots succeeds")

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")

if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")

    testA.ConnectServer()
    time.sleep(15)
    testA.AddTags()
    time.sleep(15)
    testA.SaveSnapshots()
    time.sleep(15)
    testA.Disconnet()