#!/usr/bin/env python
# -*- coding: gb2312 -*-
import datetime
import os
import random
import sys
import time
from datetime import date

sys.path.append("Tag")
import server, security, record, dataprovider, tag, hyperdb


class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider
        self.myTag = tag.Tag()

    def AddTag(self):
        attr = {'tagname': 'srctag', 'tagtype': 'int8'}
        try:
            self.myTagMgr.add_tag(**attr)
        except Exception as e:
            print("add_tag error: ", e.errcode)
        else:
            print("adding tag succeeds")

    def AddCalcTag(self):
        calc_attr = {'tagname': 'catag0',
                'tagtype': 'int32',
                'sourcetagname': 'srctag',
                'calcmode': hyperdb.HD3_CALC_MODE['HD3_CALC_MODE_POLL'],
                'calcperiod' :5,
                'calcexpr': '\'srctag\'+1'}
        try:
            tagcalcid = self.myTagMgr.add_calc_tag(**calc_attr)
        except Exception as e:
            print("add_calc_tag error: ", e.errcode)
        else:
            print("adding calc tag succeeds")

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")

if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")

    testA.ConnectServer()
    time.sleep(15)
    testA.AddTag()
    time.sleep(15)
    testA.AddCalcTag()
    time.sleep(15)
    testA.Disconnet()

