#!/usr/bin/env python
# -*- coding: gb2312 -*-
import datetime
import os
import random
import sys
import time
from datetime import date

sys.path.append("Tag")
import server, security, record, dataprovider, tag, collectormgr


class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider
        self.myTag = tag.Tag()
        self.myCollectorMgr = collectormgr.CollectorMgr()

    def AddCollector(self):
        collector_name = "yht"
        collector_type = 0
        collector_desc = "hahaha"
        collector_extparm = ""
        try:
            self.myCollectorMgr.add_collector(name=collector_name, collectortype=collector_type,
                                              description=collector_desc, extparam=collector_extparm)
        except Exception as e:
            print("add_collector error: ", e.errcode)
        else:
            print("adding collector succeeds")

    def QueryCollectorIdByName(self):
        collector_name = "yht"
        try:
            collector_id = self.myCollectorMgr.query_collector_id_by_name(name=collector_name).value
        except Exception as e:
            print("query_collector_id_by_name error: ", e.errcode)
        else:
            print("querying collector id by name succeeds")
            print("The collector: ", collector_name, "'s id: ", collector_id)
            return collector_id

    def AddDevice(self, collector_id):
        self.myCollector = collectormgr.Collector(id=collector_id, name="yht", type=0,
                                                  description="hahaha", extparam="")
        try:
            self.myCollector.add_device(name="OPC.SimaticHMI.CoRtHmiRTm.1", addr="127.0.0.1", port=5673,
                                        trytime=5, timeout=5, extparam="",
                                        isprimary=True, description="haha")
        except Exception as e:
            print("add_device error: ", e.errcode)
        else:
            print("adding device succeeds")

    def QueryDeviceIdByName(self, collector_id):
        self.myCollector = collectormgr.Collector(id=collector_id, name="yht", type=0,
                                                  description="hahaha", extparam="")
        try:
            device_id = self.myCollector.query_device_id_by_name(name="OPC.SimaticHMI.CoRtHmiRTm.1").value
        except Exception as e:
            print("query_device_id_by_name error: ", e.errcode)
        else:
            print("querying device id by name succeeds")
            print("The device's id: ", device_id)
            return device_id

    def AddScanGroup(self, device_id, device_name, collector_id):
        self.myDevice = collectormgr.Device(id=device_id, collectorid=collector_id, name=device_name,
                                            addr="127.0.0.1", port=5673, trytime=5,timeout=5,
                                            extparam="", isprimary=True, description="haha")
        try:
            self.myDevice.add_scan_group(name="_yht_", period=10, phase=10, scantype=0,
                                         dataaddr=0, datalen=10, description="ha",
                                         extparam="")
        except Exception as e:
            print("add_scan_group error: ", e.errcode)
        else:
            print("adding scan group succeeds")

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")

if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")

    testA.ConnectServer()
    time.sleep(15)
    testA.AddCollector()
    time.sleep(15)
    collector_id = testA.QueryCollectorIdByName()
    time.sleep(15)
    testA.AddDevice(collector_id=collector_id)
    time.sleep(15)
    device_id = testA.QueryDeviceIdByName(collector_id=collector_id)
    time.sleep(15)
    testA.AddScanGroup(device_id=device_id, device_name="OPC.SimaticHMI.CoRtHmiRTm.1",
                       collector_id=collector_id)
    time.sleep(15)
    testA.Disconnet()
