#!/usr/bin/env python
# -*- coding: gb2312 -*-
import datetime
import os
import random
import sys
import time
from datetime import date

sys.path.append("Tag")
import server, security, record, dataprovider, tag, collectormgr


class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider
        self.myTag = tag.Tag()
        self.myCollectorMgr = collectormgr.CollectorMgr()

    def AddCollector(self):
        collector_name = "yht"
        collector_type = 0
        collector_desc = "hahaha"
        collector_extparm = ""
        try:
            self.myCollectorMgr.add_collector(name=collector_name, collectortype=collector_type,
                                              description=collector_desc, extparam=collector_extparm)
        except Exception as e:
            print("add_collector error: ", e.errcode)
        else:
            print("adding collector succeeds")

    def QueryCollectorIdByName(self):
        collector_name = "yht"
        try:
            collector_id = self.myCollectorMgr.query_collector_id_by_name(name=collector_name)
        except Exception as e:
            print("query_collector_id_by_name error: ", e.errcode)
        else:
            print("querying collector id by name succeeds")
            print("The collector: ", collector_name, "'s id: ", collector_id.value)
            return collector_id.value

    def AddDevice(self, collector_id):
        self.myCollector = collectormgr.Collector(id=collector_id, name="yht", type=0,
                                                  description="hahaha", extparam="")
        try:
            self.myCollector.add_device(name="device-1", addr="127.0.0.1", port=5673,
                                        trytime=5, timeout=5, extparam="",
                                        isprimary=True, description="heihei")
            self.myCollector.add_device(name="device-2", addr="127.0.0.1", port=5673,
                                        trytime=5, timeout=5, extparam="",
                                        isprimary=True, description="haha")
            self.myCollector.add_device(name="device-3", addr="127.0.0.1", port=5673,
                                        trytime=5, timeout=5, extparam="",
                                        isprimary=True, description="hoho")
        except Exception as e:
            print("add_device error: ", e.errcode)
        else:
            print("adding device succeeds")

    def GetAllDevices(self):
        self.myCollector = collectormgr.Collector(id=collector_id, name="yht", type=0,
                                                  description="hahaha", extparam="")
        try:
            device_iter = self.myCollector.get_all_devices()
        except Exception as e:
            print("get_all_devices error: ", e.errcode)
        else:
            print("getting all device succeeds")
            while True:
                device = device_iter.get_next()
                if device is None:
                    break
                else:
                    print("The device's name: ", device.name, "\t",
                          "the device's id: ", device.id, "\t",
                          "the device's description: ", device.description)


    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")

if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")

    testA.ConnectServer()
    time.sleep(15)
    testA.AddCollector()
    time.sleep(15)
    collector_id = testA.QueryCollectorIdByName()
    time.sleep(15)
    testA.AddDevice(collector_id=collector_id)
    time.sleep(15)
    testA.GetAllDevices()
    time.sleep(5)
    testA.Disconnet()
