#!/usr/bin/env python
# -*- coding: gb2312 -*-
import ctypes
import datetime
import os
import random
import sys
import time
from datetime import date

sys.path.append("Tag")
import server, security, record, dataprovider, tag


class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider
        self.myTag = tag.Tag()

    def AddTags(self):
        attr = [{'tagname': 'tag_int16_10', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_11', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_12', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_13', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_14', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_15', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_16', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_17', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_18', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_19', 'tagtype': 'int8'}]
        try:
            self.myTagMgr.add_tags(attr)
        except Exception as e:
            print("add_tag error: ", e.errcode)
        else:
            print("adding tags succeeds")

    def SaveSnapshots(self):
        tagnames = []
        tagname_list = []
        time_stamp = []
        snapshot_list = []
        for i in range(10, 20):
            tagnames.append('tag_int16_' + str(i))
        for i in tagnames:
            for minute in range(50, 56):
                for sec in [0, 10, 20, 30, 40, 50]:
                    time_rec = "2023-10-17 13:" + str(minute) + ":" + str(sec)
                    # תΪʱ
                    time_rec = time.strptime(time_rec, "%Y-%m-%d %H:%M:%S")
                    # תΪʱ
                    time_stamp.append(int(time.mktime(time_rec)))
        len_time_stamp = len(time_stamp)
        for i in range(len_time_stamp):
            tagname_list.append(tagnames[int(i / 36)])
        try:
            ret = self.myTagMgr.get_tagIDs(tagnames=tagname_list)
        except Exception as e:
            print("get_tagIDs error", e.errcode)
        tagIDs = ret[1]
        for i in range(len_time_stamp):
            hdrecord = record.Record(time_stamp[i], 0)
            hdrecord.tagtype = self.myTagMgr.get_tagType(tagIDs[i])
            hdrecord.quality = random.randint(182, 192)
            hdrecord.value = random.randint(0, 10)
            snapshot_list.append((tagIDs[i], hdrecord))
        try:
            self.myTag.save_snapshots(snapshots_list=snapshot_list)
        except Exception as e:
            print("save_snapshots error", e.errcode)
        else:
            print("saving snapshots succeeds")

    def GetInterRecordsMultitagsByMode(self):
        tagnames = []
        for i in range(10, 20):
            tagnames.append('tag_int16_' + str(i))
        try:
            ret = self.myTagMgr.get_tagIDs(tagnames)
        except Exception as e:
            print("get_tagIDs error: ", e.errcode)
        tagIDs = ret[1]
        try:
            snapshots_ret = self.myDateProvider.get_snapshot_by_IDs(tagIDs)
        except Exception as e:
            print("get_snapshot_by_IDs error: ", e.errcode)
        snapshots = snapshots_ret[1]
        tagtypes = []
        times = []
        for i_hdrecord in snapshots:
            tagtypes.append(i_hdrecord.tagtype)
        for i in range(10):
            self.dattime = datetime.datetime(2023, 10, 17, 13, 53, 37)
            times.append(self.dattime)
        try:
            recret = self.myTag.get_inter_records_multitags_by_mode(mode=1, nTagIDs=tagIDs, strTagTypes=tagtypes, times=times)
        except Exception as e:
            print("get_inter_records_multitags_by_mode error: ", e.errcode)
        else:
            print("getting inter_records_multitags_by_mode succeeds")
            hdrecord_ret = recret[1]
            for i in range(len(tagnames)):
                print(tagnames[i], ":snapshot quality: ", hdrecord_ret[i].quality, "snapshot value: ", hdrecord_ret[i].value, ", timestamp: ",
                  hdrecord_ret[i].sec)

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")


if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")

    testA.ConnectServer()
    testA.AddTags()
    time.sleep(15)
    testA.SaveSnapshots()
    time.sleep(15)
    testA.GetInterRecordsMultitagsByMode()
    time.sleep(15)
    testA.Disconnet()

