#!/usr/bin/env python
# -*- coding: gb2312 -*-
import ctypes
import datetime
import os
import random
import sys
import time
from datetime import date

sys.path.append("Tag")
import server, security, record, dataprovider


class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider

    def AddTags(self):
        attr = [{'tagname': 'tag_int16_0', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_1', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_2', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_3', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_4', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_5', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_6', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_7', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_8', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_9', 'tagtype': 'int8'}]
        try:
            self.myTagMgr.add_tags(attr)
        except Exception as e:
            print("add_tags error: ", e.errcode)
        else:
            print("adding tags succeeds")

    def SaveSnapshots(self):
        tagname = "tag_int16_0"
        tagnames = []
        time_stamp = []
        hdrecord_list = []
        snapshot_list = []
        try:
            self.myTag_1 = self.myTagMgr.get_tag(tagname)
        except Exception as e:
            print(e)
        for minute in range(10, 20):
            for sec in [0, 10, 20, 30, 40, 50]:
                time_rec = "2023-11-9 08:" + str(minute) + ":" + str(sec)
                # תΪʱ
                time_rec = time.strptime(time_rec, "%Y-%m-%d %H:%M:%S")
                # תΪʱ
                time_stamp.append(int(time.mktime(time_rec)))
        len_time_stamp = len(time_stamp)
        for i in range(len_time_stamp):
            tagnames.append(tagname)
        try:
            ret = self.myTagMgr.get_tagIDs(tagnames)
        except Exception as e:
            print("get_tagIDs error: ", e.errcode)
        for i in range(len_time_stamp):
            hdrecord = record.Record(time_stamp[i], 0)
            hdrecord.tagtype = self.myTag_1.tagtype
            hdrecord.quality = 192
            hdrecord.value = random.randint(0, 10)
            hdrecord_list.append(hdrecord)
        for i in range(len_time_stamp):
            snapshot_list.append((ret[1][i], hdrecord_list[i]))
        try:
            self.myTag_1.save_snapshots(snapshot_list)
        except Exception as e:
            print("save_snapshots error: ", e.errcode)
        else:
            print("saving snapshots succeeds")

    def GetRawRecords(self):
        tagname = 'tag_int16_0'
        try:
            self.myTag_2 = self.myTagMgr.get_tag(tagname)
        except Exception as e:
            print(e)
        sttime = datetime.datetime(2023, 11, 9, 8, 11, 40)
        edtime = datetime.datetime(2023, 11, 9, 8, 13, 50)
        try:
            hdrecored_list = self.myTag_2.get_raw_records(starttime=sttime, endtime=edtime)
        except Exception as e:
            print("get_raw_records error: ", e.errcode)
        else:
            print("getting raw records succeeds")
            print("The record_list's number is ", len(hdrecored_list))
            for i in range(len(hdrecored_list)):
                time_local = time.localtime(hdrecored_list[i].sec)
                print("snapshot quality: ", hdrecored_list[i].quality, "snapshot value: ",
                      hdrecored_list[i].value, ", time: ", time.strftime("%Y-%m-%d %H:%M:%S",time_local))

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")


if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")

    testA.ConnectServer()
    time.sleep(15)
    testA.AddTags()
    time.sleep(20)
    testA.SaveSnapshots()
    time.sleep(15)
    testA.GetRawRecords()
    time.sleep(15)
    testA.Disconnet()