#!/usr/bin/env python
# -*- coding: gb2312 -*-
import datetime
import os
import random
import sys
import time
from datetime import date

sys.path.append("Tag")
import server, security, record, dataprovider, tag, collectormgr


class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider
        self.myTag = tag.Tag()
        self.myCollectorMgr = collectormgr.CollectorMgr()

    def AddCollector(self):
        collector_name = "yht"
        collector_type = 0
        collector_desc = "hahaha"
        collector_extparm = ""
        try:
            self.myCollectorMgr.add_collector(name=collector_name, collectortype=collector_type,
                                              description=collector_desc, extparam=collector_extparm)
        except Exception as e:
            print("add_collector error: ", e.errcode)
        else:
            print("adding collector succeeds")

    def GetCollectorID(self):
        collector_name = "yht"
        try:
            ret = self.myCollectorMgr.get_collector(name=collector_name)
        except Exception as e:
            print("get_collector error: ", e.errcode)
        else:
            return ret.id

    def ModifyCollector(self, collector_id):
        collector_name = "yht"
        new_collector_name_type = 0
        new_collector_description = "heiheihei"
        new_collector_extparam = ""
        try:
            self.myCollectorMgr.modify_collector(id=collector_id, name=collector_name,
                                                 collectortype=new_collector_name_type,
                                                 description=new_collector_description,
                                                 extparam=new_collector_extparam)
        except Exception as e:
            print("modify_collector error: ", e.errcode)
        else:
            print("modifying collector succeeds")

    def GetCollector(self, collector_name):
        try:
            ret = self.myCollectorMgr.get_collector(name=collector_name)
        except Exception as e:
            print("get_collector error: ", e.errcode)
        else:
            print("getting collector succeeds")
            print("The collector's name: ", ret.name, "\t",
                  "The collector's description: ", ret.description, "\t",
                  "The collector's type: ", ret.type, "\t",
                  "The collector's extparam: ", ret.extparam)

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")

if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")

    testA.ConnectServer()
    time.sleep(15)
    testA.AddCollector()
    time.sleep(15)
    testA.GetCollector(collector_name="yht")
    time.sleep(15)
    collector_id = testA.GetCollectorID()
    time.sleep(15)
    testA.ModifyCollector(collector_id=collector_id)
    time.sleep(15)
    testA.GetCollector(collector_name="yht")
    time.sleep(15)
    testA.Disconnet()
