#!/usr/bin/env python
# -*- coding: gb2312 -*-
import os
import random
import sys
import time
from datetime import date

sys.path.append(".")
import server, security, record, dataprovider, hdUser, usergroupmgr


class TestSDK:
    def ConnectServer(self, username, password):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login(username, password)
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider
        self.myUsergroupMgr = usergroupmgr.UserGroupMgr()

    def AddGroup(self, name):
        try:
            self.myUsergroupMgr.add_group(name=name, desc='administer',)
        except Exception as e:
            print("add_group error: ", e.errcode)
        else:
            print("adding group succeeds")

    def ModifygroupDesc(self, new_description):
        try:
            self.myUsergroupMgr.modify_group_desc(name='haha', newdesc=new_description)
        except Exception as e:
            print("modify_group_desc error: ", e.errcode)
        else:
            print("modifying group desc succeeds")

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")


if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")
    testA.ConnectServer(username='admin', password='admin')
    time.sleep(20)
    testA.AddGroup(name='haha')
    time.sleep(20)
    testA.ModifygroupDesc(new_description='heihei')
    time.sleep(20)
    testA.Disconnet()

