#!/usr/bin/env python
# -*- coding: gb2312 -*-
import os
import random
import sys
import time
from datetime import date

sys.path.append("")
import server, security, record, dataprovider


class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider

    def AddTags(self):
        attr = [{'tagname': 'tag_int16_30', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_31', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_32', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_33', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_34', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_35', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_36', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_37', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_38', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_39', 'tagtype': 'int8'}]
        try:
            self.myTagMgr.add_tags(attr)
        except Exception as e:
            print("add_tags error: ", e.errcode)
        else:
            print("adding tags succeeds")

    def QueryIdsByNames(self):
        tagnames = ['hdsys_mem_0', 'tag_int16_31',
                    'tag_int16_32', 'tag_int16_33',
                    'tag_int16_34', 'hdsys_cpu_0',
                    'tag_int16_36', 'tag_int16_37',
                    'tag_int16_38', 'tag_int16_39']
        try:
            tagids, err_array = self.myTagMgr.query_ids_by_names(tagnames=tagnames)
        except Exception as e:
            print("query_ids_by_names error: ", e.errcode)
        else:
            print("querying ids by names succeeds")
            for i in range(len(tagnames)):
                print("The tag: ", tagnames[i], "'s id : ", tagids[i])

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")


if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")
    testA.ConnectServer()
    time.sleep(15)
    testA.AddTags()
    time.sleep(15)
    testA.QueryIdsByNames()
    time.sleep(15)
    testA.Disconnet()
