#!/usr/bin/env python
# -*- coding: gb2312 -*-
import datetime
import os
import random
import sys
import time
from datetime import date

sys.path.append("Tag")
import server, security, record, dataprovider, tag, hyperdb


class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider
        self.myTag = tag.Tag()

    def AddTag(self):
        attr = {'tagname': 'srctag', 'tagtype': 'int8'}
        try:
            self.myTagMgr.add_tag(**attr)
        except Exception as e:
            print("add_tag error: ", e.errcode)
        else:
            print("adding tag succeeds")

    def AddCalcTags(self):
        props = []
        for i in range(20):
            tagname = 'catag' + str(i)
            prop = {'tagname': tagname,
                      'tagtype': 'int32',
                      'calcexpr': '\'srctag\'+1',
                      'sourcetagname': 'srctag',
                      'calcmode': hyperdb.HD3_CALC_MODE['HD3_CALC_MODE_POLL'],
                      'calcperiod': 5
                      }
            props.append(prop)
        try:
            tagcalcids = self.myTagMgr.add_calc_tags(props=props)
        except Exception as e:
            print("add_calc_tags error: ", e.errcode)
        else:
            print("adding calc tags succeeds")

    def QuerySpecifyPageCalcTagsCond(self):
        nCapacity = 10
        nStartID = 0
        conds = [('tagname', 'like', '*catag*'),
                 ('tagid', '>=', '1599')]
        try:
            ret = self.myTagMgr.query_specify_page_calc_tags_cond(nCapacity=nCapacity,
                                                                  nStartID=nStartID,
                                                                  conds=conds)
        except Exception as e:
            print("query_specify_page_calc_tags_cond error: ", e.errcode)
        else:
            print("querying specify page calc tags cond succeeds")
            while True:
                hdrec = ret.get_next()
                if hdrec is None:
                    break
                else:
                    print("tag's name: ", hdrec.tagname, "\t",
                          "tag's id: ", hdrec.tagid)

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")

if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")

    testA.ConnectServer()
    time.sleep(15)
    testA.AddTag()
    time.sleep(15)
    testA.AddCalcTags()
    time.sleep(15)
    testA.QuerySpecifyPageCalcTagsCond()
    testA.Disconnet()
