#!/usr/bin/env python
# -*- coding: gb2312 -*-
import datetime
import os
import random
import sys
import time
from datetime import date

sys.path.append("Tag")
import server, security, record, dataprovider, tag, hyperdb


class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider
        self.myTag = tag.Tag()

    def AddTags(self):
        props = []
        for i in range(20):
            tagname = 'test_tag_' + str(i)
            prop = {'tagname': tagname,
                    'tagtype': 'int32',
                    'descriptor': "This is " + tagname
                    }
            props.append(prop)
        try:
            self.myTagMgr.add_tags(props)
        except Exception as e:
            print("add_tags error: ", e.errcode)
        else:
            print("adding tags succeeds")

    def QuerySpecifyPageCommTagsCond(self):
        nCapacity = 10
        nStartID = 0
        conds = [('tagname', 'like', '*test_tag*'),
                 ('tagid', '>=', '100')]
        try:
            ret = self.myTagMgr.query_specify_page_comm_tags_cond(nCapacity=nCapacity,
                                                                  nStartID=nStartID,
                                                                  conds=conds)
        except Exception as e:
            print("query_specify_page_comm_tags_cond error: ", e.errcode)
        else:
            print("querying specify page comm tags cond succeeds")
            while True:
                hdrec = ret.get_next()
                if hdrec is None:
                    break
                else:
                    print("tag's name: ", hdrec.tagname, "\t",
                          "tag's id: ", hdrec.tagid, "\t",
                          "tag's descriptor: ", hdrec.descriptor)

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")

if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")

    testA.ConnectServer()
    time.sleep(15)
    testA.AddTags()
    time.sleep(15)
    testA.QuerySpecifyPageCommTagsCond()
    testA.Disconnet()
