#!/usr/bin/env python
# -*- coding: gb2312 -*-
import datetime
import os
import random
import sys
import time
from datetime import date

sys.path.append("Tag")
import server, security, record, dataprovider, tag, hyperdb


class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider
        self.myTag = tag.Tag()

    def AddTag(self):
        attr = {'tagname': 'srctag', 'tagtype': 'int8'}
        try:
            self.myTagMgr.add_tag(**attr)
        except Exception as e:
            print("add_tag error: ", e.errcode)
        else:
            print("adding tag succeeds")

    def AddStatsTags(self):
        props = []
        for i in range(30):
            tagname = 'statstag' + str(i)
            prop = {'tagname': tagname,
                     'tagtype': 'float64',
                     'sourcetagname':'srctag',
                     'samplestartdate': 0,
                     'sampleinterval': 10,
                     'samplemode': 0,
                     'statstype': 0,
                     'calcperiod': 1,
                     'scanperiod': 10,
                     'sampletype': 0,
                     'samplestartdate': 1,
                     'descriptor': tagname
                    }
            props.append(prop)
        try:
            tagids = self.myTagMgr.add_stats_tags(props=props)
        except Exception as e:
            print("add_stats_tags error: ", e.errcode)
        else:
            print("adding stats tags succeeds")

    def QuerySpecifyPageStatsTagsCond(self):
        nCapacity = 15
        nStartID = 0
        conds = [('tagname', 'like', '*statstag*'),
                 ('tagid', '>=', '10')]
        try:
            ret = self.myTagMgr.query_specify_page_stats_tags_cond(nCapacity=nCapacity,
                                                                  nStartID=nStartID,
                                                                  conds=conds)
        except Exception as e:
            print("query_specify_page_stats_tags_cond error: ", e.errcode)
        else:
            print("querying specify page stats tags cond succeeds")
            while True:
                hdrec = ret.get_next()
                if hdrec is None:
                    break
                else:
                    print("tag's name: ", hdrec.tagname, "\t",
                          "tag's id: ", hdrec.tagid, "\t",
                          "tag's description: ", hdrec.descriptor)

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")

if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")

    testA.ConnectServer()
    time.sleep(15)
    testA.AddTag()
    time.sleep(15)
    testA.AddStatsTags()
    time.sleep(15)
    testA.QuerySpecifyPageStatsTagsCond()
    time.sleep(15)
    testA.Disconnet()
