#!/usr/bin/env python
# -*- coding: gb2312 -*-
import os
import random
import sys
import time
from datetime import date

sys.path.append("MgrTag")
import server, security, record, dataprovider, hyperdb


class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider

    def AddTags(self):
        attr = [{'tagname': 'srctag0', 'tagtype': 'int32'},
                {'tagname': 'srctag1', 'tagtype': 'int32'},
                {'tagname': 'srctag2', 'tagtype': 'int32'},
                {'tagname': 'srctag3', 'tagtype': 'int32'},
                {'tagname': 'srctag4', 'tagtype': 'int32'}]
        try:
            self.myTagMgr.add_tags(attr)
        except Exception as e:
            print("add_tags error: ", e.errcode)
        else:
            print("adding tags succeeds")

    def QueryTagNumCond(self):
        nTagClass_1 = hyperdb.HD3_TAG_CLASS['HD3_TAG_CLASS_BASIC']
        conds = [('tagname', 'like', '*srctag*'),
                 ('tagid', '>=', '10')]
        try:
            tag_num = self.myTagMgr.query_tag_num_cond(nTagClass=nTagClass_1, conds=conds)
        except Exception as e:
            print("query_tag_num_cond error: ", e.errcode)
        else:
            print("querying tag num cond succeeds")
            print("The number is ", tag_num)

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")


if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")
    testA.ConnectServer()
    # time.sleep(15)
    # testA.AddTags()
    # time.sleep(15)
    testA.QueryTagNumCond()
    testA.Disconnet()
