#!/usr/bin/env python
# -*- coding: gb2312 -*-
import os
import random
import sys
import time
from datetime import date

sys.path.append("MgrTag")
import server, security, record, dataprovider,  hyperdb


class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider

    def AddTags(self):
        attr = [{'tagname': 'tag_int16_30', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_31', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_32', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_33', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_34', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_35', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_36', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_37', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_38', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_39', 'tagtype': 'int8'}]
        try:
            self.myTagMgr.add_tags(attr)
        except Exception as e:
            print("add_tags error: ", e.errcode)
        else:
            print("adding tags succeeds")

    def QueryTagsBasicInfoByName(self):
        tagclassmask = hyperdb.HD3_TAG_CLASS_MASK['HD3M_ALL']
        tagnames = ['hdsys_cpu_0', 'hdsys_mem_0', 'hdsys_netin_0',
                    'tag_int16_30', 'tag_int16_33', 'tag_int16_39']
        tagnum = len(tagnames)
        try:
            tag_basicinfo, pErrCodeArray = self.myTagMgr.query_tags_basic_info_by_name(tagclassmask=tagclassmask,
                                                                        tagnum=tagnum,
                                                                        tagnames=tagnames)
        except Exception as e:
            print("query_tags_basic_info_by_name error: ", e.errcode)
        else:
            print("querying tags basic info by name succeeds")
            for i in range(len(tag_basicinfo)):
                print("the tag's name: ", tag_basicinfo[i].tagname, "\t",
                      "the tag's id: ", tag_basicinfo[i].tagid, "\t",
                      "the tag's type: ", tag_basicinfo[i].tagtype, "\t",
                      "the tag's class: ", tag_basicinfo[i].tagclass)

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")


if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")
    testA.ConnectServer()
    time.sleep(15)
    testA.AddTags()
    time.sleep(15)
    testA.QueryTagsBasicInfoByName()
    time.sleep(15)
    testA.Disconnet()
