#!/usr/bin/env python
# -*- coding: gb2312 -*-
import datetime
import os
import random
import sys
import time
from datetime import date

sys.path.append("Tag")
import server, security, record, dataprovider, tag, hyperdb


class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider
        self.myTag = tag.Tag()

    def AddTag(self):
        attr = {'tagname': 'srctag', 'tagtype': 'int8', 'descriptor': 'srctag'}
        try:
            comm_tagid = self.myTagMgr.add_tag(**attr)
        except Exception as e:
            print("add_tag error: ", e.errcode)
        else:
            print("adding tag succeeds")
            return comm_tagid

    def AddStatsTags(self):
        props = [{'tagname': 'sttag0',
                  'tagtype': 'float64',
                  'sourcetagname': 'srctag',
                  'samplestartdate': 0,
                  'sampleinterval': 10,
                  'samplemode': 0,
                  'statstype': 0,
                  'calcperiod': 1,
                  'scanperiod': 10,
                  'sampletype': 0,
                  'samplestartdate': 1,
                  'descriptor': 'sttag0'
                  }, {'tagname': 'sttag1',
                      'tagtype': 'float64',
                      'sourcetagname': 'srctag',
                      'samplestartdate': 0,
                      'sampleinterval': 10,
                      'samplemode': 0,
                      'statstype': 0,
                      'calcperiod': 2,
                      'scanperiod': 10,
                      'sampletype': 0,
                      'samplestartdate': 1,
                      'descriptor': 'sttag1'
                      }]
        try:
            tagstatids = self.myTagMgr.add_stats_tags(props=props)
        except Exception as e:
            print("add_stats_tags error: ", e.errcode)
        else:
            print("adding stats tags succeeds")
            return tagstatids

    def AddCalcTags(self):
        props = [{'tagname': 'catag0',
                  'tagtype': 'int32',
                  'calcexpr': '\'srctag\'+1',
                  'sourcetagname': 'srctag',
                  'calcmode': hyperdb.HD3_CALC_MODE['HD3_CALC_MODE_POLL'],
                  'calcperiod': 5,
                  'descriptor': 'catag0'
                  }, {'tagname': 'catag1',
                      'tagtype': 'int32',
                      'calcexpr': '\'srctag\'+1',
                      'sourcetagname': 'srctag',
                      'calcmode': hyperdb.HD3_CALC_MODE['HD3_CALC_MODE_POLL'],
                      'calcperiod': 5,
                      'descriptor': 'catag0'
                      }]
        try:
            tagcalcids = self.myTagMgr.add_calc_tags(props=props)
        except Exception as e:
            print("add_calc_tags error: ", e.errcode)
        else:
            print("adding calc tags succeeds")
            return tagcalcids

    def AddAlarmTags(self):
        props = [{'tagname': 'amtag0',
                  'tagtype': 'int32',
                  'sourcetagname': 'srctag',
                  'descriptor': 'amtag0',
                  }, {'tagname': 'amtag1',
                      'tagtype': 'int32',
                      'sourcetagname': 'srctag',
                      'descriptor': 'amtag1',
                      }]
        try:
            tagalarmids = self.myTagMgr.add_alarm_tags(props=props)
        except Exception as e:
            print("add_alarm_tags error: ", e.errcode)
        else:
            print("adding alarm tags succeeds")
            return tagalarmids

    def QueryTagsCommonProp(self):
        tagnames = ['srctag', 'sttag0', 'sttag1', 'catag0', 'catag1', 'amtag0']
        tagids = []
        tagnum = len(tagnames)
        for tagname in tagnames:
            try:
                tagid = self.myTagMgr.query_id_by_name(tagname=tagname)
            except Exception as e:
                print("query_id_by_name error: ", e.errcodee)
            else:
                tagids.append(tagid)
        tagclassmask = hyperdb.HD3_TAG_CLASS_MASK['HD3M_ALL']
        try:
            prop_array = self.myTagMgr.query_tags_common_prop(tagclassmask=tagclassmask, tagnum=tagnum, tagids=tagids)
        except Exception as e:
            print("query_tags_common_prop error: ", e.errcode)
        else:
            print("query_tags_common_prop succeeds")
            for prop in prop_array:
                print("The tag's name: ", prop.tagname, "\t",
                      "The tag's nTagid: ", prop.tagid, "\t",
                      "The tag's descriptor: ", prop.descriptor)

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")


if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")

    testA.ConnectServer()
    time.sleep(15)
    comm_tagid = testA.AddTag()
    time.sleep(15)
    tagstatids = testA.AddStatsTags()
    time.sleep(15)
    tagcalcids = testA.AddCalcTags()
    time.sleep(15)
    tagalarmids = testA.AddAlarmTags()
    time.sleep(15)
    testA.QueryTagsCommonProp()
    time.sleep(15)
    testA.Disconnet()
