#!/usr/bin/env python
# -*- coding: gb2312 -*-
import datetime
import os
import random
import sys
import time
from datetime import date

sys.path.append("Tag")
import server, security, record, dataprovider, tag, hyperdb


class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider
        self.myTag = tag.Tag()

    def AddTag(self):
        attr = {'tagname': 'srctag', 'tagtype': 'int8'}
        try:
            self.myTagMgr.add_tag(**attr)
        except Exception as e:
            print("add_tag error: ", e.errcode)
        else:
            print("adding tag succeeds")

    def AddStatsTags(self):
        props = [{'tagname': 'sttag0',
                     'tagtype': 'float64',
                     'sourcetagname':'srctag',
                     'samplestartdate': 0,
                     'sampleinterval':10,
                     'samplemode':0,
                     'statstype': 0,
                     'calcperiod':1,
                     'scanperiod':10,
                     'sampletype':0,
                     'samplestartdate': 1
                     },{'tagname': 'sttag1',
                      'tagtype': 'float64',
                     'sourcetagname':'srctag',
                     'samplestartdate': 0,
                     'sampleinterval':10,
                     'samplemode':0,
                     'statstype': 0,
                     'calcperiod':2,
                     'scanperiod':10,
                     'sampletype':0,
                     'samplestartdate':1
                     }]
        try:
            tagids = self.myTagMgr.add_stats_tags(props=props)
        except Exception as e:
            print("add_stats_tags error: ", e.errcode)
        else:
            print("adding stats tags succeeds")

    def AddCalcTags(self):
        props = [{'tagname': 'catag0',
                      'tagtype': 'int32',
                      'calcexpr': '\'srctag\'+1',
                     'sourcetagname':'srctag',
                     'calcmode' : hyperdb.HD3_CALC_MODE['HD3_CALC_MODE_POLL'],
                     'calcperiod' :5
                     },{'tagname': 'catag1',
                      'tagtype': 'int32',
                      'calcexpr': '\'srctag\'+1',
                     'sourcetagname':'srctag',
                     'calcmode' : hyperdb.HD3_CALC_MODE['HD3_CALC_MODE_POLL'],
                     'calcperiod' :5
                     }]
        try:
            tagcalcids = self.myTagMgr.add_calc_tags(props=props)
        except Exception as e:
            print("add_calc_tags error: ", e.errcode)
        else:
            print("adding calc tags succeeds")

    def AddAlarmTags(self):
        props = [{'tagname': 'amtag0',
                      'tagtype': 'int32',
                      'sourcetagname': 'srctag'
                     },{'tagname': 'amtag1',
                      'tagtype': 'int32',
                      'sourcetagname': 'srctag'
                     }]
        try:
            tagalarmids = self.myTagMgr.add_alarm_tags(props=props)
        except Exception as e:
            print("add_alarm_tags error: ", e.errcode)
        else:
            print("adding alarm tags succeeds")

    def QueryTagsCond(self):
        conds = [('tagid', '>=', '13')]
        try:
            ret = self.myTagMgr.query_tags_cond(conds=conds, tagclassmask=hyperdb.HD3_TAG_CLASS_MASK['HD3M_ALL'])
        except Exception as e:
            print("query_tags_cond error: ", e.errcode)
        else:
            print("querying tags cond succeeds")
            while True:
                hdrec = ret.get_next()
                if hdrec is None:
                    break
                else:
                    print("tag's name: ", hdrec.tagname, "\t",
                          "tag's id: ", hdrec.tagid)

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")

if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")

    testA.ConnectServer()
    time.sleep(15)
    testA.AddTag()
    time.sleep(15)
    testA.AddStatsTags()
    time.sleep(15)
    testA.AddCalcTags()
    time.sleep(15)
    testA.AddAlarmTags()
    time.sleep(15)
    testA.QueryTagsCond()
    time.sleep(15)
    testA.Disconnet()
