#!/usr/bin/env python
# -*- coding: gb2312 -*-
import datetime
import os
import random
import sys
import time
from datetime import date

sys.path.append("Tag")
import server, security, record, dataprovider, tag


class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider
        self.myTag = tag.Tag()

    def AddTags(self):
        attr = [{'tagname': 'tag_int16_10', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_11', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_12', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_13', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_14', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_15', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_16', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_17', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_18', 'tagtype': 'int8'},
                {'tagname': 'tag_int16_19', 'tagtype': 'int8'}]
        try:
            self.myTagMgr.add_tags(attr)
        except Exception as e:
            print("add_tags error: ", e.errcode)
        else:
            print("adding tags succeeds")

    def SaveTagsDisorderSnapshots(self):
        tagname_list = ['tag_int16_10', 'tag_int16_11',
                    'tag_int16_12', 'tag_int16_13',
                    'tag_int16_14', 'tag_int16_15',
                    'tag_int16_16', 'tag_int16_17',
                    'tag_int16_18', 'tag_int16_19']
        tagnames = []
        for i in range(600):
            index = int(i / 60)
            tagnames.append(tagname_list[index])

        # ȡtagids
        try:
            tagids, pErrCodeArray = self.myTagMgr.query_ids_by_names(tagnames=tagnames)
        except Exception as e:
            print("query_ids_by_names error: ", e.errcode)

        # ȡʱ
        time_stamp = []
        for i in tagname_list:
            for minute in range(10, 20):
                for sec in [20, 40, 0, 30, 10, 50]:
                    time_rec = "2023-10-18 09:" + str(minute) + ":" + str(sec)
                    # תΪʱ
                    time_rec = time.strptime(time_rec, "%Y-%m-%d %H:%M:%S")
                    # תΪʱ
                    time_stamp.append(int(time.mktime(time_rec)))

        # ȡrecarray
        recarray = []
        len_time_stamp = len(time_stamp)
        for i in range(len_time_stamp):
            hdrecord = record.Record(time_stamp[i], 0)
            hdrecord.tagtype = self.myTagMgr.get_tagType(tagids[i])
            hdrecord.quality = random.randint(182, 192)
            hdrecord.value = random.randint(0, 10)
            recarray.append(hdrecord)

        # save_tags_disorder_snapshots
        try:
            self.myTag.save_tags_disorder_snapshots(tagidarray=tagids, recarray=recarray)
        except Exception as e:
            print("save_tags_disorder_snapshots error: ", e.errcode)
        else:
            print("saving tags disorder snapshots succeeds")

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")

if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")

    testA.ConnectServer()
    # time.sleep(15)
    # testA.AddTags()
    # time.sleep(20)
    testA.SaveTagsDisorderSnapshots()
    time.sleep(15)
    testA.Disconnet()
