#!/usr/bin/env python
# -*- coding: gb2312 -*-
import os
import random
import sys
import time
from datetime import date

sys.path.append(".")
import server, security, record, dataprovider


class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.set_request_timeout(timeout=10)
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider
        ## set charset


    def AddTag(self):
        attr = {'tagname': 'testtag', 'tagtype': 'int8'}
        try:
            self.myTagMgr.add_tag(**attr)
        except Exception as e:
            print("add_tag error: ", e.errcode)
        else:
            print("adding tag succeeds")

    def SaveSnapshot(self):
        try:
            self.myTag = self.myTagMgr.get_tag('testtag')
        except Exception as e:
            print(e)
        hdrecord = record.Record(int(time.strftime('%m%d%H%M%S', time.localtime())), 0)
        hdrecord.tagtype = self.myTag.tagtype
        hdrecord.quality = 192
        hdrecord.value = 12
        try:
            self.myTag.save_snapshot(hdrecord)
        except Exception as e:
            print("save_snapshot error: ", e.errcode)
        else:
            print("saving snapshot succeeds")

    def Disconnet(self):
        try:
            self.myTagMgr.delete_tag('testtag')
        except Exception as e:
            print("delete_tag error: ", e.errcode)
        self.myServer.disconnect()


if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")

    testA.ConnectServer()
    time.sleep(10)
    testA.AddTag()
    time.sleep(10)
    testA.SaveSnapshot()
    time.sleep(10)
    testA.Disconnet()