#!/usr/bin/env python
# -*- coding: gb2312 -*-
import os
import random
import sys
import time
from datetime import date

sys.path.append("")
import server, security, record, dataprovider, hyperdb


class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider

    def AddTag(self):
        attr = {'tagname': 'testtag', 'tagtype': 'int32'}
        try:
            self.myTagMgr.add_tag(**attr)
        except Exception as e:
            print("add_tag error: ", e.errcode)
        else:
            print("adding tag succeeds")

    def SaveSnapshots(self):
        tagname = 'testtag'
        snapshots_list = []
        self.myTag = self.myTagMgr.get_tag(tagname)
        cnt = 1
        sec_list = ["00", "10", "20", "30", "40", "50"]
        for i in range(20, 30):
            for sec in sec_list:
                rectime = "2023-11-02 13:" + str(i) + ":" + sec
                timestamp = int(time.mktime(time.strptime(rectime, "%Y-%m-%d %H:%M:%S")))
                tagid = self.myTagMgr.get_tag(tagname).tagid
                hdrecord = record.Record(timestamp, 0)
                hdrecord.tagtype = self.myTag.tagtype
                hdrecord.quality = 192
                hdrecord.value = cnt / 3 % 5
                snapshots_list.append((tagid, hdrecord))
                cnt = cnt + 1
        try:
            self.myTag.save_snapshots(snapshots_list=snapshots_list)
        except Exception as e:
            print("save_snapshots error: ", e.errcode)
        else:
            print("saving snapshots succeeds")

    def GetTagID(self):
        tagname = 'testtag'
        tagid = 0
        try:
            tagid = self.myTagMgr.get_tag(tagname).tagid
        except Exception as e:
            print("get_tag error: ", e.errcode)
        return tagid

    ## ȡƽֵ
    def TagStatsCalcArithMean(self, tagid):
        pTimeRegions_left = hyperdb.HD3Time()
        pTimeRegions_left.nSec = 1698902430
        pTimeRegions_left.nMsec = 0
        pTimeRegions_right = hyperdb.HD3Time()
        pTimeRegions_right.nSec = 1698902970
        pTimeRegions_right.nMsec = 0
        param = {'nStatsType': hyperdb.HD3_STATS_TYPE['HD3_STATS_TYPE_ARITH_MEAN'],
                 'nTimeRegionNum': 1,
                 'pTimeRegions_left': pTimeRegions_left,
                 'pTimeRegions_right': pTimeRegions_right,
                 'pTimeRegions_leftclosed': True,
                 'pTimeRegions_rightclosed': False,
                 'pfPercentGood': 0,
                 'nSampleType': hyperdb.HD3_STATS_SAMPLE_TYPE['HD3_STATS_SAMPLE_TYPE_RAW'],
                 'szFilterExpr': "",
                 'nFilterFailMode': 0,
                 'dExtParam1': 0,
                 'dExtParam2': 0,
                 'nOffset': 0,
                 'nPeriod': 0,
                 'bUseBadValue': False
                 }
        try:
            value = self.myTagMgr.tag_stats_calc(nTagID=tagid, **param)
        except Exception as e:
            print("tag_stats_calc error: ", e.errcode)
        else:
            print("test-1    The STATS_TYPE_ARITH_MEANs value: ", value, "\n")

    ## ȡֵ
    def TagStatsCalcMax(self, tagid):
        pTimeRegions_left = hyperdb.HD3Time()
        pTimeRegions_left.nSec = 1698902430
        pTimeRegions_left.nMsec = 0
        pTimeRegions_right = hyperdb.HD3Time()
        pTimeRegions_right.nSec = 1698902970
        pTimeRegions_right.nMsec = 0
        param = {'nStatsType': hyperdb.HD3_STATS_TYPE['HD3_STATS_TYPE_MAX'],
                 'nTimeRegionNum': 1,
                 'pTimeRegions_left': pTimeRegions_left,
                 'pTimeRegions_right': pTimeRegions_right,
                 'pTimeRegions_leftclosed': True,
                 'pTimeRegions_rightclosed': False,
                 'pfPercentGood': 0,
                 'nSampleType': hyperdb.HD3_STATS_SAMPLE_TYPE['HD3_STATS_SAMPLE_TYPE_RAW'],
                 'szFilterExpr': "",
                 'nFilterFailMode': 0,
                 'dExtParam1': 0,
                 'dExtParam2': 0,
                 'nOffset': 0,
                 'nPeriod': 0,
                 'bUseBadValue': False
                 }
        try:
            value = self.myTagMgr.tag_stats_calc(nTagID=tagid, **param)
        except Exception as e:
            print("tag_stats_calc error: ", e.errcode)
        else:
            print("test-2    The STATS_TYPE_MAXs value: ", value, "\n")

    ## ȡСֵ
    def TagStatsCalcMin(self, tagid):
        pTimeRegions_left = hyperdb.HD3Time()
        pTimeRegions_left.nSec = 1698902430
        pTimeRegions_left.nMsec = 0
        pTimeRegions_right = hyperdb.HD3Time()
        pTimeRegions_right.nSec = 1698902970
        pTimeRegions_right.nMsec = 0
        param = {'nStatsType': hyperdb.HD3_STATS_TYPE['HD3_STATS_TYPE_MIN'],
                 'nTimeRegionNum': 1,
                 'pTimeRegions_left': pTimeRegions_left,
                 'pTimeRegions_right': pTimeRegions_right,
                 'pTimeRegions_leftclosed': True,
                 'pTimeRegions_rightclosed': False,
                 'pfPercentGood': 0,
                 'nSampleType': hyperdb.HD3_STATS_SAMPLE_TYPE['HD3_STATS_SAMPLE_TYPE_RAW'],
                 'szFilterExpr': "",
                 'nFilterFailMode': 0,
                 'dExtParam1': 0,
                 'dExtParam2': 0,
                 'nOffset': 0,
                 'nPeriod': 0,
                 'bUseBadValue': False
                 }
        try:
            value = self.myTagMgr.tag_stats_calc(nTagID=tagid, **param)
        except Exception as e:
            print("tag_stats_calc error: ", e.errcode)
        else:
            print("test-3    The STATS_TYPE_MINs value: ", value, "\n")

    ## ȡ
    def TagStatsCalcSum(self, tagid):
        pTimeRegions_left = hyperdb.HD3Time()
        pTimeRegions_left.nSec = 1698902430
        pTimeRegions_left.nMsec = 0
        pTimeRegions_right = hyperdb.HD3Time()
        pTimeRegions_right.nSec = 1698902970
        pTimeRegions_right.nMsec = 0
        param = {'nStatsType': hyperdb.HD3_STATS_TYPE['HD3_STATS_TYPE_SUM'],
                 'nTimeRegionNum': 1,
                 'pTimeRegions_left': pTimeRegions_left,
                 'pTimeRegions_right': pTimeRegions_right,
                 'pTimeRegions_leftclosed': True,
                 'pTimeRegions_rightclosed': False,
                 'pfPercentGood': 0,
                 'nSampleType': hyperdb.HD3_STATS_SAMPLE_TYPE['HD3_STATS_SAMPLE_TYPE_RAW'],
                 'szFilterExpr': "",
                 'nFilterFailMode': 0,
                 'dExtParam1': 0,
                 'dExtParam2': 0,
                 'nOffset': 0,
                 'nPeriod': 0,
                 'bUseBadValue': False
                 }
        try:
            value = self.myTagMgr.tag_stats_calc(nTagID=tagid, **param)
        except Exception as e:
            print("tag_stats_calc error: ", e.errcode)
        else:
            print("test-4    The STATS_TYPE_SUMs value: ", value, "\n")

    ## ȡֵ
    def TagStatsCalcLast(self, tagid):
        pTimeRegions_left = hyperdb.HD3Time()
        pTimeRegions_left.nSec = 1698902430
        pTimeRegions_left.nMsec = 0
        pTimeRegions_right = hyperdb.HD3Time()
        pTimeRegions_right.nSec = 1698902970
        pTimeRegions_right.nMsec = 0
        param = {'nStatsType': hyperdb.HD3_STATS_TYPE['HD3_STATS_TYPE_LAST'],
                 'nTimeRegionNum': 1,
                 'pTimeRegions_left': pTimeRegions_left,
                 'pTimeRegions_right': pTimeRegions_right,
                 'pTimeRegions_leftclosed': True,
                 'pTimeRegions_rightclosed': False,
                 'pfPercentGood': 0,
                 'nSampleType': hyperdb.HD3_STATS_SAMPLE_TYPE['HD3_STATS_SAMPLE_TYPE_RAW'],
                 'szFilterExpr': "",
                 'nFilterFailMode': 0,
                 'dExtParam1': 0,
                 'dExtParam2': 0,
                 'nOffset': 0,
                 'nPeriod': 0,
                 'bUseBadValue': False
                 }
        try:
            value = self.myTagMgr.tag_stats_calc(nTagID=tagid, **param)
        except Exception as e:
            print("tag_stats_calc error: ", e.errcode)
        else:
            print("test-5    The STATS_TYPE_LASTs value: ", value, "\n")

    ## ȡŶ
    def TagStatsCalcPctGood(self, tagid):
        pTimeRegions_left = hyperdb.HD3Time()
        pTimeRegions_left.nSec = 1698902430
        pTimeRegions_left.nMsec = 0
        pTimeRegions_right = hyperdb.HD3Time()
        pTimeRegions_right.nSec = 1698902970
        pTimeRegions_right.nMsec = 0
        param = {'nStatsType': hyperdb.HD3_STATS_TYPE['HD3_STATS_TYPE_PCT_GOOD'],
                 'nTimeRegionNum': 1,
                 'pTimeRegions_left': pTimeRegions_left,
                 'pTimeRegions_right': pTimeRegions_right,
                 'pTimeRegions_leftclosed': True,
                 'pTimeRegions_rightclosed': False,
                 'pfPercentGood': 0,
                 'nSampleType': hyperdb.HD3_STATS_SAMPLE_TYPE['HD3_STATS_SAMPLE_TYPE_RAW'],
                 'szFilterExpr': "",
                 'nFilterFailMode': 0,
                 'dExtParam1': 0,
                 'dExtParam2': 0,
                 'nOffset': 0,
                 'nPeriod': 0,
                 'bUseBadValue': False
                 }
        try:
            value = self.myTagMgr.tag_stats_calc(nTagID=tagid, **param)
        except Exception as e:
            print("tag_stats_calc error: ", e.errcode)
        else:
            print("test-6    The STATS_TYPE_PCT_GOODs value: ", value, "\n")

    ## ȡʱȨƽֵ
    def TagStatsCalcTimeWeightedMean(self, tagid):
        pTimeRegions_left = hyperdb.HD3Time()
        pTimeRegions_left.nSec = 1698902430
        pTimeRegions_left.nMsec = 0
        pTimeRegions_right = hyperdb.HD3Time()
        pTimeRegions_right.nSec = 1698902970
        pTimeRegions_right.nMsec = 0
        param = {'nStatsType': hyperdb.HD3_STATS_TYPE['HD3_STATS_TYPE_TIME_WEIGHTED_MEAN'],
                 'nTimeRegionNum': 1,
                 'pTimeRegions_left': pTimeRegions_left,
                 'pTimeRegions_right': pTimeRegions_right,
                 'pTimeRegions_leftclosed': True,
                 'pTimeRegions_rightclosed': False,
                 'pfPercentGood': 0,
                 'nSampleType': hyperdb.HD3_STATS_SAMPLE_TYPE['HD3_STATS_SAMPLE_TYPE_RAW'],
                 'szFilterExpr': "",
                 'nFilterFailMode': 0,
                 'dExtParam1': 0,
                 'dExtParam2': 0,
                 'nOffset': 0,
                 'nPeriod': 0,
                 'bUseBadValue': False
                 }
        try:
            value = self.myTagMgr.tag_stats_calc(nTagID=tagid, **param)
        except Exception as e:
            print("tag_stats_calc error: ", e.errcode)
        else:
            print("test-7    The STATS_TYPE_TIME_WEIGHTED_MEANs value: ", value, "\n")

    ## ȡ
    def TagStatsCalcIntegral(self, tagid):
        pTimeRegions_left = hyperdb.HD3Time()
        pTimeRegions_left.nSec = 1698902430
        pTimeRegions_left.nMsec = 0
        pTimeRegions_right = hyperdb.HD3Time()
        pTimeRegions_right.nSec = 1698902970
        pTimeRegions_right.nMsec = 0
        param = {'nStatsType': hyperdb.HD3_STATS_TYPE['HD3_STATS_TYPE_INTEGRAL'],
                 'nTimeRegionNum': 1,
                 'pTimeRegions_left': pTimeRegions_left,
                 'pTimeRegions_right': pTimeRegions_right,
                 'pTimeRegions_leftclosed': True,
                 'pTimeRegions_rightclosed': False,
                 'pfPercentGood': 0,
                 'nSampleType': hyperdb.HD3_STATS_SAMPLE_TYPE['HD3_STATS_SAMPLE_TYPE_RAW'],
                 'szFilterExpr': "",
                 'nFilterFailMode': 0,
                 'dExtParam1': 0,
                 'dExtParam2': 0,
                 'nOffset': 0,
                 'nPeriod': 0,
                 'bUseBadValue': False
                 }
        try:
            value = self.myTagMgr.tag_stats_calc(nTagID=tagid, **param)
        except Exception as e:
            print("tag_stats_calc error: ", e.errcode)
        else:
            print("test-8    The STATS_TYPE_INTEGRALs value: ", value, "\n")

    ## ȡֵͳ
    def TagStatsCalcDiff(self, tagid):
        pTimeRegions_left = hyperdb.HD3Time()
        pTimeRegions_left.nSec = 1698902430
        pTimeRegions_left.nMsec = 0
        pTimeRegions_right = hyperdb.HD3Time()
        pTimeRegions_right.nSec = 1698902970
        pTimeRegions_right.nMsec = 0
        param = {'nStatsType': hyperdb.HD3_STATS_TYPE['HD3_STATS_TYPE_DIFF'],
                 'nTimeRegionNum': 1,
                 'pTimeRegions_left': pTimeRegions_left,
                 'pTimeRegions_right': pTimeRegions_right,
                 'pTimeRegions_leftclosed': True,
                 'pTimeRegions_rightclosed': False,
                 'pfPercentGood': 0,
                 'nSampleType': hyperdb.HD3_STATS_SAMPLE_TYPE['HD3_STATS_SAMPLE_TYPE_RAW'],
                 'szFilterExpr': "",
                 'nFilterFailMode': 0,
                 'dExtParam1': 0,
                 'dExtParam2': 0,
                 'nOffset': 0,
                 'nPeriod': 0,
                 'bUseBadValue': False
                 }
        try:
            value = self.myTagMgr.tag_stats_calc(nTagID=tagid, **param)
        except Exception as e:
            print("tag_stats_calc error: ", e.errcode)
        else:
            print("test-9    The STATS_TYPE_DIFFs value: ", value, "\n")

    ## ȡ
    def TagStatsCalcRange(self, tagid):
        pTimeRegions_left = hyperdb.HD3Time()
        pTimeRegions_left.nSec = 1698902430
        pTimeRegions_left.nMsec = 0
        pTimeRegions_right = hyperdb.HD3Time()
        pTimeRegions_right.nSec = 1698902970
        pTimeRegions_right.nMsec = 0
        param = {'nStatsType': hyperdb.HD3_STATS_TYPE['HD3_STATS_TYPE_RANGE'],
                 'nTimeRegionNum': 1,
                 'pTimeRegions_left': pTimeRegions_left,
                 'pTimeRegions_right': pTimeRegions_right,
                 'pTimeRegions_leftclosed': True,
                 'pTimeRegions_rightclosed': False,
                 'pfPercentGood': 0,
                 'nSampleType': hyperdb.HD3_STATS_SAMPLE_TYPE['HD3_STATS_SAMPLE_TYPE_RAW'],
                 'szFilterExpr': "",
                 'nFilterFailMode': 0,
                 'dExtParam1': 0,
                 'dExtParam2': 0,
                 'nOffset': 0,
                 'nPeriod': 0,
                 'bUseBadValue': False
                 }
        try:
            value = self.myTagMgr.tag_stats_calc(nTagID=tagid, **param)
        except Exception as e:
            print("tag_stats_calc error: ", e.errcode)
        else:
            print("test-10    The STATS_TYPE_RANGEs value: ", value, "\n")

    ## ȡ׼
    def TagStatsCalcStandardDeviation(self, tagid):
        pTimeRegions_left = hyperdb.HD3Time()
        pTimeRegions_left.nSec = 1698902430
        pTimeRegions_left.nMsec = 0
        pTimeRegions_right = hyperdb.HD3Time()
        pTimeRegions_right.nSec = 1698902970
        pTimeRegions_right.nMsec = 0
        param = {'nStatsType': hyperdb.HD3_STATS_TYPE['HD3_STATS_TYPE_STANDARD_DEVIATION'],
                 'nTimeRegionNum': 1,
                 'pTimeRegions_left': pTimeRegions_left,
                 'pTimeRegions_right': pTimeRegions_right,
                 'pTimeRegions_leftclosed': True,
                 'pTimeRegions_rightclosed': False,
                 'pfPercentGood': 0,
                 'nSampleType': hyperdb.HD3_STATS_SAMPLE_TYPE['HD3_STATS_SAMPLE_TYPE_RAW'],
                 'szFilterExpr': "",
                 'nFilterFailMode': 0,
                 'dExtParam1': 0,
                 'dExtParam2': 0,
                 'nOffset': 0,
                 'nPeriod': 0,
                 'bUseBadValue': False
                 }
        try:
            value = self.myTagMgr.tag_stats_calc(nTagID=tagid, **param)
        except Exception as e:
            print("tag_stats_calc error: ", e.errcode)
        else:
            print("test-11    The STATS_TYPE_STANDARD_DEVIATIONs value: ", value, "\n")

    ## -->ֵ仯
    # Ϊ3ʵӦΪ4
    def TagStatsCalcCountChgValue(self, tagid):
        pTimeRegions_left = hyperdb.HD3Time()
        pTimeRegions_left.nSec = 1698902430
        pTimeRegions_left.nMsec = 0
        pTimeRegions_right = hyperdb.HD3Time()
        pTimeRegions_right.nSec = 1698902970
        pTimeRegions_right.nMsec = 0
        param = {'nStatsType': hyperdb.HD3_STATS_TYPE['HD3_STATS_TYPE_COUNT_CHG_VALUE'],
                 'nTimeRegionNum': 1,
                 'pTimeRegions_left': pTimeRegions_left,
                 'pTimeRegions_right': pTimeRegions_right,
                 'pTimeRegions_leftclosed': True,
                 'pTimeRegions_rightclosed': False,
                 'pfPercentGood': 0,
                 'nSampleType': hyperdb.HD3_STATS_SAMPLE_TYPE['HD3_STATS_SAMPLE_TYPE_RAW'],
                 'szFilterExpr': "",
                 'nFilterFailMode': 0,
                 'dExtParam1': 2,
                 'dExtParam2': 3,
                 'nOffset': 0,
                 'nPeriod': 0,
                 'bUseBadValue': False
                 }
        try:
            value = self.myTagMgr.tag_stats_calc(nTagID=tagid, **param)
        except Exception as e:
            print("tag_stats_calc error: ", e.errcode)
        else:
            print("test-12    The STATS_TYPE_COUNT_CHG_VALUEs value: ", value, "\n")

    ## -->仯,<=>=
    # ???   tag_stats_calc error:  119651
    # ʵʽӦΪ4
    def TagStatsCalcCountChgFromLessToGreat(self, tagid):
        pTimeRegions_left = hyperdb.HD3Time()
        pTimeRegions_left.nSec = 1698902430
        pTimeRegions_left.nMsec = 0
        pTimeRegions_right = hyperdb.HD3Time()
        pTimeRegions_right.nSec = 1698902970
        pTimeRegions_right.nMsec = 0
        param = {'nStatsType': hyperdb.HD3_STATS_TYPE['HD3_STATS_TYPE_COUNT_CHG_FROM_LESS_TO_GREAT'],
                 'nTimeRegionNum': 1,
                 'pTimeRegions_left': pTimeRegions_left,
                 'pTimeRegions_right': pTimeRegions_right,
                 'pTimeRegions_leftclosed': True,
                 'pTimeRegions_rightclosed': False,
                 'pfPercentGood': 0,
                 'nSampleType': hyperdb.HD3_STATS_SAMPLE_TYPE['HD3_STATS_SAMPLE_TYPE_RAW'],
                 'szFilterExpr': "",
                 'nFilterFailMode': 0,
                 'dExtParam1': 2,
                 'dExtParam2': 3,
                 'nOffset': 0,
                 'nPeriod': 0,
                 'bUseBadValue': False
                 }
        try:
            value = self.myTagMgr.tag_stats_calc(nTagID=tagid, **param)
        except Exception as e:
            print("tag_stats_calc error: ", e.errcode)
        else:
            print("test-13    The STATS_TYPE_COUNT_CHG_FROM_LESS_TO_GREATs value: ", value, "\n")

    ## -->仯>=<=
    # Ϊ3ʵʽӦΪ0
    def TagStatsCalcCountChgFromGreatToLess(self, tagid):
        pTimeRegions_left = hyperdb.HD3Time()
        pTimeRegions_left.nSec = 1698902430
        pTimeRegions_left.nMsec = 0
        pTimeRegions_right = hyperdb.HD3Time()
        pTimeRegions_right.nSec = 1698902970
        pTimeRegions_right.nMsec = 0
        param = {'nStatsType': hyperdb.HD3_STATS_TYPE['HD3_STATS_TYPE_COUNT_CHG_FROM_GREAT_TO_LESS'],
                 'nTimeRegionNum': 1,
                 'pTimeRegions_left': pTimeRegions_left,
                 'pTimeRegions_right': pTimeRegions_right,
                 'pTimeRegions_leftclosed': True,
                 'pTimeRegions_rightclosed': False,
                 'pfPercentGood': 0,
                 'nSampleType': hyperdb.HD3_STATS_SAMPLE_TYPE['HD3_STATS_SAMPLE_TYPE_RAW'],
                 'szFilterExpr': "",
                 'nFilterFailMode': 0,
                 'dExtParam1': 5,
                 'dExtParam2': 2,
                 'nOffset': 0,
                 'nPeriod': 0,
                 'bUseBadValue': False
                 }
        try:
            value = self.myTagMgr.tag_stats_calc(nTagID=tagid, **param)
        except Exception as e:
            print("tag_stats_calc error: ", e.errcode)
        else:
            print("test-14    The STATS_TYPE_COUNT_CHG_FROM_GREAT_TO_LESSs value: ", value, "\n")

    ## -->ֵ
    # ???   dExtParam 
    # ???   tag_stats_calc error:  119651
    # ʵʽӦΪ12
    def TagStatsCalcCountInRange(self, tagid):
        pTimeRegions_left = hyperdb.HD3Time()
        pTimeRegions_left.nSec = 1698902430
        pTimeRegions_left.nMsec = 0
        pTimeRegions_right = hyperdb.HD3Time()
        pTimeRegions_right.nSec = 1698902970
        pTimeRegions_right.nMsec = 0
        param = {'nStatsType': hyperdb.HD3_STATS_TYPE['HD3_STATS_TYPE_COUNT_IN_RANGE'],
                 'nTimeRegionNum': 1,
                 'pTimeRegions_left': pTimeRegions_left,
                 'pTimeRegions_right': pTimeRegions_right,
                 'pTimeRegions_leftclosed': True,
                 'pTimeRegions_rightclosed': False,
                 'pfPercentGood': 0,
                 'nSampleType': hyperdb.HD3_STATS_SAMPLE_TYPE['HD3_STATS_SAMPLE_TYPE_RAW'],
                 'szFilterExpr': "",
                 'nFilterFailMode': 0,
                 'dExtParam1': 2,
                 'dExtParam2': 3,
                 'nOffset': 0,
                 'nPeriod': 0,
                 'bUseBadValue': False
                 }
        try:
            value = self.myTagMgr.tag_stats_calc(nTagID=tagid, **param)
        except Exception as e:
            print("tag_stats_calc error: ", e.errcode)
        else:
            print("test-15    The STATS_TYPE_COUNT_IN_RANGEs value: ", value, "\n")

    ## -->ֵ
    # ???   dExtParam 
    # ???   tag_stats_calc error:  119651
    # ʵʽӦΪ10
    def TagStatsCalcCountNotInRange(self, tagid):
        pTimeRegions_left = hyperdb.HD3Time()
        pTimeRegions_left.nSec = 1698902430
        pTimeRegions_left.nMsec = 0
        pTimeRegions_right = hyperdb.HD3Time()
        pTimeRegions_right.nSec = 1698902970
        pTimeRegions_right.nMsec = 0
        param = {'nStatsType': hyperdb.HD3_STATS_TYPE['HD3_STATS_TYPE_COUNT_NOT_IN_RANGE'],
                 'nTimeRegionNum': 1,
                 'pTimeRegions_left': pTimeRegions_left,
                 'pTimeRegions_right': pTimeRegions_right,
                 'pTimeRegions_leftclosed': True,
                 'pTimeRegions_rightclosed': False,
                 'pfPercentGood': 0,
                 'nSampleType': hyperdb.HD3_STATS_SAMPLE_TYPE['HD3_STATS_SAMPLE_TYPE_RAW'],
                 'szFilterExpr': "",
                 'nFilterFailMode': 0,
                 'dExtParam1': 0,
                 'dExtParam2': 4,
                 'nOffset': 0,
                 'nPeriod': 0,
                 'bUseBadValue': False
                 }
        try:
            value = self.myTagMgr.tag_stats_calc(nTagID=tagid, **param)
        except Exception as e:
            print("tag_stats_calc error: ", e.errcode)
        else:
            print("test-16    The STATS_TYPE_COUNT_NOT_IN_RANGEs value: ", value, "\n")

    ## ʱ-->ĳֵdExtParam2ʱ
    def TagStatsCalcTimeGt(self, tagid):
        pTimeRegions_left = hyperdb.HD3Time()
        pTimeRegions_left.nSec = 1698902430
        pTimeRegions_left.nMsec = 0
        pTimeRegions_right = hyperdb.HD3Time()
        pTimeRegions_right.nSec = 1698902970
        pTimeRegions_right.nMsec = 0
        param = {'nStatsType': hyperdb.HD3_STATS_TYPE['HD3_STATS_TYPE_TIME_GT'],
                 'nTimeRegionNum': 1,
                 'pTimeRegions_left': pTimeRegions_left,
                 'pTimeRegions_right': pTimeRegions_right,
                 'pTimeRegions_leftclosed': True,
                 'pTimeRegions_rightclosed': False,
                 'pfPercentGood': 0,
                 'nSampleType': hyperdb.HD3_STATS_SAMPLE_TYPE['HD3_STATS_SAMPLE_TYPE_RAW'],
                 'szFilterExpr': "",
                 'nFilterFailMode': 0,
                 'dExtParam1': 0,
                 'dExtParam2': 3,
                 'nOffset': 0,
                 'nPeriod': 0,
                 'bUseBadValue': False
                 }
        try:
            value = self.myTagMgr.tag_stats_calc(nTagID=tagid, **param)
        except Exception as e:
            print("tag_stats_calc error: ", e.errcode)
        else:
            print("test-17    The STATS_TYPE_TIME_GTs value: ", value, "\n")

    ## ʱ-->ڵĳֵdExtParam2ʱ
    def TagStatsCalcTimeGe(self, tagid):
        pTimeRegions_left = hyperdb.HD3Time()
        pTimeRegions_left.nSec = 1698902430
        pTimeRegions_left.nMsec = 0
        pTimeRegions_right = hyperdb.HD3Time()
        pTimeRegions_right.nSec = 1698902970
        pTimeRegions_right.nMsec = 0
        param = {'nStatsType': hyperdb.HD3_STATS_TYPE['HD3_STATS_TYPE_TIME_GE'],
                 'nTimeRegionNum': 1,
                 'pTimeRegions_left': pTimeRegions_left,
                 'pTimeRegions_right': pTimeRegions_right,
                 'pTimeRegions_leftclosed': True,
                 'pTimeRegions_rightclosed': False,
                 'pfPercentGood': 0,
                 'nSampleType': hyperdb.HD3_STATS_SAMPLE_TYPE['HD3_STATS_SAMPLE_TYPE_RAW'],
                 'szFilterExpr': "",
                 'nFilterFailMode': 0,
                 'dExtParam1': 0,
                 'dExtParam2': 4,
                 'nOffset': 0,
                 'nPeriod': 0,
                 'bUseBadValue': False
                 }
        try:
            value = self.myTagMgr.tag_stats_calc(nTagID=tagid, **param)
        except Exception as e:
            print("tag_stats_calc error: ", e.errcode)
        else:
            print("test-18    The STATS_TYPE_TIME_GEs value: ", value, "\n")

    ## ʱ-->ĳֵdExtParam2ʱ
    def TagStatsCalcTimeEq(self, tagid):
        pTimeRegions_left = hyperdb.HD3Time()
        pTimeRegions_left.nSec = 1698902430
        pTimeRegions_left.nMsec = 0
        pTimeRegions_right = hyperdb.HD3Time()
        pTimeRegions_right.nSec = 1698902970
        pTimeRegions_right.nMsec = 0
        param = {'nStatsType': hyperdb.HD3_STATS_TYPE['HD3_STATS_TYPE_TIME_EQ'],
                 'nTimeRegionNum': 1,
                 'pTimeRegions_left': pTimeRegions_left,
                 'pTimeRegions_right': pTimeRegions_right,
                 'pTimeRegions_leftclosed': True,
                 'pTimeRegions_rightclosed': False,
                 'pfPercentGood': 0,
                 'nSampleType': hyperdb.HD3_STATS_SAMPLE_TYPE['HD3_STATS_SAMPLE_TYPE_RAW'],
                 'szFilterExpr': "",
                 'nFilterFailMode': 0,
                 'dExtParam1': 0,
                 'dExtParam2': 4,
                 'nOffset': 0,
                 'nPeriod': 0,
                 'bUseBadValue': False
                 }
        try:
            value = self.myTagMgr.tag_stats_calc(nTagID=tagid, **param)
        except Exception as e:
            print("tag_stats_calc error: ", e.errcode)
        else:
            print("test-19    The STATS_TYPE_TIME_EQs value: ", value, "\n")

    ## ʱ-->ĳֵdExtParam2ʱ
    def TagStatsCalcTimeNe(self, tagid):
        pTimeRegions_left = hyperdb.HD3Time()
        pTimeRegions_left.nSec = 1698902430
        pTimeRegions_left.nMsec = 0
        pTimeRegions_right = hyperdb.HD3Time()
        pTimeRegions_right.nSec = 1698902970
        pTimeRegions_right.nMsec = 0
        param = {'nStatsType': hyperdb.HD3_STATS_TYPE['HD3_STATS_TYPE_TIME_NE'],
                 'nTimeRegionNum': 1,
                 'pTimeRegions_left': pTimeRegions_left,
                 'pTimeRegions_right': pTimeRegions_right,
                 'pTimeRegions_leftclosed': True,
                 'pTimeRegions_rightclosed': False,
                 'pfPercentGood': 0,
                 'nSampleType': hyperdb.HD3_STATS_SAMPLE_TYPE['HD3_STATS_SAMPLE_TYPE_RAW'],
                 'szFilterExpr': "",
                 'nFilterFailMode': 0,
                 'dExtParam1': 0,
                 'dExtParam2': 1,
                 'nOffset': 0,
                 'nPeriod': 0,
                 'bUseBadValue': False
                 }
        try:
            value = self.myTagMgr.tag_stats_calc(nTagID=tagid, **param)
        except Exception as e:
            print("tag_stats_calc error: ", e.errcode)
        else:
            print("test-20    The STATS_TYPE_TIME_NEs value: ", value, "\n")

    ## ʱ-->Сĳֵʱ䣨dExtParam2
    def TagStatsCalcTimeLt(self, tagid):
        pTimeRegions_left = hyperdb.HD3Time()
        pTimeRegions_left.nSec = 1698902430
        pTimeRegions_left.nMsec = 0
        pTimeRegions_right = hyperdb.HD3Time()
        pTimeRegions_right.nSec = 1698902970
        pTimeRegions_right.nMsec = 0
        param = {'nStatsType': hyperdb.HD3_STATS_TYPE['HD3_STATS_TYPE_TIME_LT'],
                 'nTimeRegionNum': 1,
                 'pTimeRegions_left': pTimeRegions_left,
                 'pTimeRegions_right': pTimeRegions_right,
                 'pTimeRegions_leftclosed': True,
                 'pTimeRegions_rightclosed': False,
                 'pfPercentGood': 0,
                 'nSampleType': hyperdb.HD3_STATS_SAMPLE_TYPE['HD3_STATS_SAMPLE_TYPE_RAW'],
                 'szFilterExpr': "",
                 'nFilterFailMode': 0,
                 'dExtParam1': 0,
                 'dExtParam2': 3,
                 'nOffset': 0,
                 'nPeriod': 0,
                 'bUseBadValue': False
                 }
        try:
            value = self.myTagMgr.tag_stats_calc(nTagID=tagid, **param)
        except Exception as e:
            print("tag_stats_calc error: ", e.errcode)
        else:
            print("test-21    The STATS_TYPE_TIME_LTs value: ", value, "\n")

    ## ʱ-->Сڵĳֵʱ䣨dExtParam2
    def TagStatsCalcTimeLe(self, tagid):
        pTimeRegions_left = hyperdb.HD3Time()
        pTimeRegions_left.nSec = 1698902430
        pTimeRegions_left.nMsec = 0
        pTimeRegions_right = hyperdb.HD3Time()
        pTimeRegions_right.nSec = 1698902970
        pTimeRegions_right.nMsec = 0
        param = {'nStatsType': hyperdb.HD3_STATS_TYPE['HD3_STATS_TYPE_TIME_LE'],
                 'nTimeRegionNum': 1,
                 'pTimeRegions_left': pTimeRegions_left,
                 'pTimeRegions_right': pTimeRegions_right,
                 'pTimeRegions_leftclosed': True,
                 'pTimeRegions_rightclosed': False,
                 'pfPercentGood': 0,
                 'nSampleType': hyperdb.HD3_STATS_SAMPLE_TYPE['HD3_STATS_SAMPLE_TYPE_RAW'],
                 'szFilterExpr': "",
                 'nFilterFailMode': 0,
                 'dExtParam1': 0,
                 'dExtParam2': 3,
                 'nOffset': 0,
                 'nPeriod': 0,
                 'bUseBadValue': False
                 }
        try:
            value = self.myTagMgr.tag_stats_calc(nTagID=tagid, **param)
        except Exception as e:
            print("tag_stats_calc error: ", e.errcode)
        else:
            print("test-22    The STATS_TYPE_TIME_LEs value: ", value, "\n")

    ## ʱ-->ĳֵʱ
    # ??? ֵһֱ
    # ӦΪ540
    def TagStatsCalcTimeInRange(self, tagid):
        pTimeRegions_left = hyperdb.HD3Time()
        pTimeRegions_left.nSec = 1698902430
        pTimeRegions_left.nMsec = 0
        pTimeRegions_right = hyperdb.HD3Time()
        pTimeRegions_right.nSec = 1698902970
        pTimeRegions_right.nMsec = 0
        param = {'nStatsType': hyperdb.HD3_STATS_TYPE['HD3_STATS_TYPE_TIME_IN_RANGE'],
                 'nTimeRegionNum': 1,
                 'pTimeRegions_left': pTimeRegions_left,
                 'pTimeRegions_right': pTimeRegions_right,
                 'pTimeRegions_leftclosed': True,
                 'pTimeRegions_rightclosed': False,
                 'pfPercentGood': 0,
                 'nSampleType': hyperdb.HD3_STATS_SAMPLE_TYPE['HD3_STATS_SAMPLE_TYPE_RAW'],
                 'szFilterExpr': "",
                 'nFilterFailMode': 0,
                 'dExtParam1': 0,
                 'dExtParam2': 6,
                 'nOffset': 0,
                 'nPeriod': 0,
                 'bUseBadValue': False
                 }
        try:
            value = self.myTagMgr.tag_stats_calc(nTagID=tagid, **param)
        except Exception as e:
            print("tag_stats_calc error: ", e.errcode)
        else:
            print("test-23    The STATS_TYPE_TIME_IN_RANGEs value: ", value, "\n")

    ## ʱ-->ĳֵʱ
    # ??? ֵһֱ540
    # ӦΪ420
    def TagStatsCalcTimeNotInRange(self, tagid):
        pTimeRegions_left = hyperdb.HD3Time()
        pTimeRegions_left.nSec = 1698902430
        pTimeRegions_left.nMsec = 0
        pTimeRegions_right = hyperdb.HD3Time()
        pTimeRegions_right.nSec = 1698902970
        pTimeRegions_right.nMsec = 0
        param = {'nStatsType': hyperdb.HD3_STATS_TYPE['HD3_STATS_TYPE_TIME_NOT_IN_RANGE'],
                 'nTimeRegionNum': 1,
                 'pTimeRegions_left': pTimeRegions_left,
                 'pTimeRegions_right': pTimeRegions_right,
                 'pTimeRegions_leftclosed': True,
                 'pTimeRegions_rightclosed': False,
                 'pfPercentGood': 0,
                 'nSampleType': hyperdb.HD3_STATS_SAMPLE_TYPE['HD3_STATS_SAMPLE_TYPE_RAW'],
                 'szFilterExpr': "",
                 'nFilterFailMode': 0,
                 'dExtParam1': 0,
                 'dExtParam2': 1,
                 'nOffset': 0,
                 'nPeriod': 0,
                 'bUseBadValue': False
                 }
        try:
            value = self.myTagMgr.tag_stats_calc(nTagID=tagid, **param)
        except Exception as e:
            print("tag_stats_calc error: ", e.errcode)
        else:
            print("test-24    The STATS_TYPE_TIME_NOT_IN_RANGEs value: ", value, "\n")

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")


if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")

    testA.ConnectServer()
    time.sleep(15)
    testA.AddTag()
    time.sleep(20)
    testA.SaveSnapshots()
    time.sleep(15)
    tagid = testA.GetTagID()
    time.sleep(15)
    testA.TagStatsCalcArithMean(tagid=tagid)
    time.sleep(15)
    testA.TagStatsCalcMax(tagid=tagid)
    time.sleep(15)
    testA.TagStatsCalcMin(tagid=tagid)
    time.sleep(15)
    testA.TagStatsCalcSum(tagid=tagid)
    time.sleep(15)
    testA.TagStatsCalcLast(tagid=tagid)
    time.sleep(15)
    testA.TagStatsCalcPctGood(tagid=tagid)
    time.sleep(15)
    testA.TagStatsCalcTimeWeightedMean(tagid=tagid)
    time.sleep(15)
    testA.TagStatsCalcIntegral(tagid=tagid)
    time.sleep(15)
    testA.TagStatsCalcDiff(tagid=tagid)
    time.sleep(15)
    testA.TagStatsCalcRange(tagid=tagid)
    time.sleep(15)
    testA.TagStatsCalcStandardDeviation(tagid=tagid)
    time.sleep(15)
    testA.TagStatsCalcCountChgValue(tagid=tagid)
    time.sleep(15)
    testA.TagStatsCalcCountChgFromLessToGreat(tagid=tagid)
    time.sleep(15)
    testA.TagStatsCalcCountChgFromGreatToLess(tagid=tagid)
    time.sleep(15)
    testA.TagStatsCalcCountInRange(tagid=tagid)
    time.sleep(15)
    testA.TagStatsCalcCountNotInRange(tagid=tagid)
    time.sleep(15)
    testA.TagStatsCalcTimeGt(tagid=tagid)
    time.sleep(15)
    testA.TagStatsCalcTimeGe(tagid=tagid)
    time.sleep(15)
    testA.TagStatsCalcTimeEq(tagid=tagid)
    time.sleep(15)
    testA.TagStatsCalcTimeNe(tagid=tagid)
    time.sleep(15)
    testA.TagStatsCalcTimeLt(tagid=tagid)
    time.sleep(15)
    testA.TagStatsCalcTimeLe(tagid=tagid)
    time.sleep(15)
    testA.TagStatsCalcTimeInRange(tagid=tagid)
    time.sleep(15)
    testA.TagStatsCalcTimeNotInRange(tagid=tagid)
    time.sleep(15)
    testA.Disconnet()
