#!/usr/bin/env python
# -*- coding: gb2312 -*-
import datetime
import os
import random
import sys
import time
from datetime import date

sys.path.append("Tag")
import server, security, record, dataprovider, tag, collectormgr


class TestSDK:
    def ConnectServer(self):
        self.myServer = server.Server('127.0.0.1', 5673, '', 5673)
        self.myServer.connect()
        self.myServer.login('admin', 'admin')
        self.myTagMgr = self.myServer.tag_mgr
        self.myDateProvider = self.myServer.data_provider
        self.myTag = tag.Tag()
        self.myCollectorMgr = collectormgr.CollectorMgr()

    def AddCollector(self):
        collector_name = ["yht", "steph", "KT"]
        collector_type = [0, 0, 0]
        collector_desc = ["hahaha", "heiheihei", "hohoho"]
        collector_extparm = ["", "", ""]
        try:
            for i in range(3):
                self.myCollectorMgr.add_collector(name=collector_name[i], collectortype=collector_type[i],
                                              description=collector_desc[i], extparam=collector_extparm[i])
        except Exception as e:
            print("add_collector error: ", e.errcode)
        else:
            print("adding collector succeeds")

    def QueryCollectorsStatus(self, collector_ids):
        try:
            ret = self.myCollectorMgr.query_collectors_status(nnum=3, pcollectoridarray=collector_ids)
        except Exception as e:
            print("query_collector_status error", e.errcode)
        else:
            print("querying collector status succeeds")
            collector_status_list = ret[1]
            for i in range(len(collector_status_list)):
                print("The collector's Quality:", collector_status_list[i].nQuality, "\t",
                      "The collector's TotalTagNum:", collector_status_list[i].nTotalTagNum, "\t",
                      "The collector's ActiveTagNum:", collector_status_list[i].nActiveTagNum)

    def QueryCollectorIdByName(self, collector_name):
        try:
            collector_id = self.myCollectorMgr.query_collector_id_by_name(name=collector_name).value
        except Exception as e:
            print("query_collector_id_by_name error: ", e.errcode)
        else:
            print("querying collector id by name succeeds")
            print("The collector: ", collector_name, "'s id: ", collector_id)
            return collector_id

    def AddDevice(self, collector_id, collector_name):
        self.myCollector = collectormgr.Collector(id=collector_id, name=collector_name,
                                                  type=0, description="hahaha", extparam="")
        try:
            self.myCollector.add_device(name="test1", addr="127.0.0.1", port=5673,
                                        trytime=5, timeout=5, extparam="",
                                        isprimary=True, description="haha")
            self.myCollector.add_device(name="test2", addr="127.0.0.1", port=5673,
                                        trytime=5, timeout=5, extparam="",
                                        isprimary=True, description="heihei")
        except Exception as e:
            print("add_device error: ", e.errcode)
        else:
            print("adding device succeeds")

    def QueryDiviceIDByName(self, collector_id, collector_name, device_name):
        self.myCollector = collectormgr.Collector(id=collector_id, name=collector_name,
                                                  type=0, description="hahaha", extparam="")
        try:
            device_id = self.myCollector.query_device_id_by_name(name=device_name).value
        except Exception as e:
            print("query_device_id_by_name error: ", e.errcode)
        else:
            print("querying device id by name succeeds")
            return device_id

    def AddScanGroup(self, collector_id, device_id):
        self.myDevice = collectormgr.Device(id=device_id, collectorid=collector_id,
                                            name="test1", addr="127.0.0.1", port=5673,
                                            trytime=5, timeout=5, extparam="", isprimary=True,
                                            description="ha")
        try:
            self.myDevice.add_scan_group(name="haha", period=10, phase=1, scantype=1,
                                         dataaddr=0, datalen=1, description="",
                                         extparam="")
        except Exception as e:
            print("add_scan_group error: ", e.errcode)
        else:
            print("adding scan group succeeds")

    def UpdateCollectorStatus(self, collector_id, quality, active_tag_num):
        len_id = len(collector_id)
        update_time = datetime.datetime.now()
        for i in range(len_id):
            try:
                self.myCollectorMgr.update_collector_status(nCollectorID=collector_id[i], nQuality=quality[i],
                                                            nActiveTagNum=active_tag_num[i], pTime=update_time)
            except Exception as e:
                print("update_collector_status error: ", e.errcode)
            else:
                print("updating collector status succeeds")

    def UpdateDeviceStatus(self, device_id, quality, active_tag_num, collector_id):
        self.myCollector = collectormgr.Collector(id=collector_id, name="yht", type=0,
                                                  description="hahaha", extparam="")
        len_id = len(device_id)
        update_time = datetime.datetime.now()
        for i in range(len_id):
            try:
                self.myCollector.update_device_status(nDeviceID=device_id[i], nQuality=quality[i],
                                                      nActiveTagNum=active_tag_num[i], pTime=update_time)
            except Exception as e:
                print("update_device_status error: ", e.errcode)
            else:
                print("updating device status succeeds")

    def QueryDevicesStatus(self, device_ids, collector_id):
        self.myCollector = collectormgr.Collector(id=collector_id, name="yht", type=0,
                                                  description="hahaha", extparam="")
        device_num = len(device_ids)
        try:
            ret = self.myCollector.query_devices_status(nnum=device_num, pdeviceidarray=device_ids)
        except Exception as e:
            print("query_devices_status error:  ", e.errcode)
        else:
            print("querying devices status succeeds")
            devices_status = ret[1]
            for index in range(len(devices_status)):
                print("The device's nQuality: ", devices_status[index].nQuality, "\t",
                      "The device's nTotalTagNum: ", devices_status[index].nTotalTagNum, "\t",
                      "The device's nActiveTagNum: ", devices_status[index].nActiveTagNum)

    def Disconnet(self):
        try:
            self.myServer.disconnect()
        except Exception as e:
            print("disconnect error: ", e.errcode)
        else:
            print("disconnecting succeeds")

if __name__ == '__main__':
    testA = TestSDK()
    print("PythonSDK_V3 sample..")

    testA.ConnectServer()
    time.sleep(15)
    testA.AddCollector()
    time.sleep(15)
    collector_names = ["yht", "steph", "KT"]
    collectorids = []
    for i in range(len(collector_names)):
        collectorid = testA.QueryCollectorIdByName(collector_name=collector_names[i])
        collectorids.append(collectorid)
    time.sleep(30)
    testA.AddDevice(collector_id=collectorids[0], collector_name=collector_names[0])
    time.sleep(30)
    device_ids = []
    device_names = ['test1', 'test2']
    for i in range(2):
        device_id = testA.QueryDiviceIDByName(collector_id=collectorids[0], collector_name=collector_names[0],
                                              device_name=device_names[i])
        device_ids.append(device_id)
    time.sleep(30)
    testA.AddScanGroup(collector_id=collectorids[0], device_id=device_ids[0])
    time.sleep(30)
    testA.UpdateCollectorStatus(collector_id=collectorids, quality=[55532, 55532, 55532], active_tag_num=[1, 2, 3])
    time.sleep(30)
    testA.QueryCollectorsStatus(collector_ids=collectorids)
    time.sleep(30)
    testA.UpdateDeviceStatus(device_id=device_ids, quality=[65529, 65529], active_tag_num=[1, 2], collector_id=collectorids[0])
    time.sleep(30)
    testA.QueryDevicesStatus(device_ids=device_ids, collector_id=collectorids[0])
    time.sleep(5)
    testA.Disconnet()
